/***************************************************************************
                          mosixview.cpp  -  description
                             -------------------
    begin                : Tue Jun 26 16:06:00 GMT 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qaccel.h>
#include "mosixview.h"
#include "filesave.xpm"
#include "fileopen.xpm"
#include "filenew.xpm"
#include "green.xpm"
#include "red.xpm"
#include "white.xpm"
#include "helpicon.xpm"
#include "remote.xpm"
#include "hosti.xpm"
#include "hosti_g.xpm"
#include "proc.xpm"
#include "proc_remote.xpm"
#include "proc_g.xpm"
#include "load.xpm"
#include "comment.xpm"
#include "config.xpm"
#include "refresh.xpm"
#include "speed.xpm"
#include "migrator.xpm"
#include "gohome.xpm"
#include "kill.xpm"
#include "ende.xpm"




MosixviewApp::MosixviewApp()
{



	QFile fp("/etc/HOSTNAME");

	if ( fp.open(IO_ReadOnly) ) {    // file opened successfully
		QTextStream t( &fp );        // use a text stream
		QString s;


			s = t.readLine();       // line of text excluding '\n'
			s = s.simplifyWhiteSpace();


  setCaption(tr("Mosixview " VERSION " on "+ s));

		fp.close();

 } else {

  setCaption(tr("Mosixview " VERSION " on localhost"));
}


  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  initActions();
  initMenuBar();
  initToolBar();
  initStatusBar();

//	  initDoc();
//	  initView();

  viewToolBar->setOn(true);
  viewStatusBar->setOn(true);

//##################################################################

	initDialog();




}

MosixviewApp::~MosixviewApp()
{
}





void  MosixviewApp::initDialog(){

	QPixmap white_pix, fresh, end;
	white_pix= QPixmap(white_xpm);
	fresh = QPixmap(refresh);
	end = QPixmap(ende);



  this->resize(660,2000);
  this->setMinimumSize(600,380);
  this->setMaximumSize(660,2000);
  QScrollBar_1= new QScrollBar(this,"NoName");
  QScrollBar_1->setGeometry(0,55,20,345);
  QScrollBar_1->setMinimumSize(0,0);
  QScrollBar_1->setRange(0,50);

  QCheckBox_1= new QCheckBox(this,"NoName");
  QCheckBox_1->setGeometry(555,40,100,20);
  QCheckBox_1->setMinimumSize(0,0);
  QCheckBox_1->setText("auto-refresh");
  QCheckBox_1->setChecked(true);

  QPushButton_70= new QPushButton(fresh, "NoName", this);
  QPushButton_70->setGeometry(475,35,70,20);
  QPushButton_70->setMinimumSize(0,0);
  QPushButton_70->setText("refresh");

  QPushButton_1= new QPushButton(end, "NoName", this);
  QPushButton_1->setGeometry(580,380,60,20);
  QPushButton_1->setMinimumSize(0,0);
  QPushButton_1->setText("quit");

  QGroupBox_1= new QGroupBox(this,"NoName");
  QGroupBox_1->setGeometry(20,55,450,170);
  QGroupBox_1->setMinimumSize(0,0);
  QGroupBox_1->setTitle("");

  QLabel_22= new QLabel(QGroupBox_1,"NoName");
  QLabel_22->setGeometry(30,10,90,20);
  QLabel_22->setMinimumSize(0,0);
  QLabel_22->setText("clusternodes");
  QLabel_22->setMargin(0);

  QLabel_6= new QLabel(QGroupBox_1,"NoName");
  QLabel_6->setGeometry(140,10,120,20);
  QLabel_6->setMinimumSize(0,0);
  QLabel_6->setText("set priority/speed");
  QLabel_6->setMargin(5);

  QLabel_2= new QLabel(QGroupBox_1,"NoName");
  QLabel_2->setGeometry(310,10,80,20);
  QLabel_2->setMinimumSize(0,0);
  QLabel_2->setText("mosix load");
  QLabel_2->setMargin(5);

  QLabel_52= new QLabel(QGroupBox_1,"NoName");
  QLabel_52->setGeometry(10,110,130,20);
  QLabel_52->setMinimumSize(0,0);
  QLabel_52->setText("last managed process:");
  QLabel_52->setMargin(2);

  QLabel_50= new QLabel(QGroupBox_1,"NoName");
  QLabel_50->setGeometry(140,110,60,20);
  QLabel_50->setMinimumSize(0,0);
  QLabel_50->setBackgroundPixmap(QPixmap(white_pix));
  QLabel_50->setText("");
  QLabel_50->setMargin(3);

  QLabel_110= new QLabel(QGroupBox_1,"NoName");
  QLabel_110->setGeometry(10,140,60,20);
  QLabel_110->setMinimumSize(0,0);
  QLabel_110->setText("Output:");
  QLabel_110->setMargin(2);

  QLabel_111= new QLabel(QGroupBox_1,"NoName");
  QLabel_111->setGeometry(140,140,280,20);
  QLabel_111->setMinimumSize(0,0);
  QLabel_111->setBackgroundPixmap(QPixmap(white_pix));
  QLabel_111->setText("");
  QLabel_111->setMargin(3);

  QPushButton_73= new QPushButton(fresh , "NoName", QGroupBox_1);
  QPushButton_73->setGeometry(5,60,65,20);
  QPushButton_73->setMinimumSize(0,0);
  QPushButton_73->setText("refresh");

  QCheckBox_2= new QCheckBox(QGroupBox_1,"NoName");
  QCheckBox_2->setGeometry(70,60,140,20);
  QCheckBox_2->setMinimumSize(0,0);
  QCheckBox_2->setText("auto-refresh status");
  QCheckBox_2->setChecked(false);
	QWhatsThis::add(QCheckBox_2 ,"Toggles auto/manually refresh of the status box.\n");

  QCheckBox_3= new QCheckBox(QGroupBox_1,"NoName");
  QCheckBox_3->setGeometry(70,80,220,20);
  QCheckBox_3->setMinimumSize(0,0);
  QCheckBox_3->setFont(QFont("helvetica", 12, 50));
  QCheckBox_3->setText("nslookup hostname in configurator");
	QWhatsThis::add(QCheckBox_3 ,"Toggles hostname lookup in the configuration dialog.(do not use this if your nodes only have ip adresses)\n");

  QCheckBox_4= new QCheckBox(QGroupBox_1,"NoName");
  QCheckBox_4->setGeometry(320,60,120,20);
  QCheckBox_4->setMinimumSize(0,0);
  QCheckBox_4->setText("load refresh on/off");
  QCheckBox_4->setChecked(true);
	QWhatsThis::add(QCheckBox_4 ,"Toggles the load-refresh.\n");


  QPushButton_rem= new QPushButton(this,"NoName");
  QPushButton_rem->setGeometry(475,365,90,35);
  QPushButton_rem->setMinimumSize(0,0);
  QPushButton_rem->setText("manage procs\nfrom remote");
	QWhatsThis::add(QPushButton_rem ,"Manage the procs from other cluster-members running on this node.\n");




}






void MosixviewApp::scroll_view( int value ) {


	int current_h=0;

	current_h=QGroupBox_1->height();
  QGroupBox_1->setGeometry ( 20, -value+55, 450, current_h );

}




void MosixviewApp::setupQuit(){

	printf("Initializing MOSIXVIEW...\n");


	QTimer *internalTimer = new QTimer( this );

	getconfig();

	connect( internalTimer, SIGNAL(timeout()), this, SLOT(typval()) );
	internalTimer->start( 500 );

	getval();
	neuwin();
	mosixstatus();
	labelconf();


	QTimer *proctimer = new QTimer( this );
	proctimer->start( 10000 );
	connect( proctimer, SIGNAL(timeout()), this, SLOT(refreshit()) );
	connect( proctimer, SIGNAL(timeout()), this, SLOT(refreshit_status()) );



	QObject::connect( QPushButton_70, SIGNAL(clicked()), this, SLOT( refreshitmanual()) );
	QObject::connect( QPushButton_73, SIGNAL(clicked()), this, SLOT( refreshit_status_manual()) );

	QObject::connect(QPushButton_1, SIGNAL(clicked()), qApp, SLOT(quit()) );

	QObject::connect( QPushButton_rem, SIGNAL(clicked()), this, SLOT( remoteproc()) );



	QObject::connect(QScrollBar_1, SIGNAL(sliderMoved ( int )), this, SLOT(scroll_view( int  )) );
	QObject::connect(QScrollBar_1, SIGNAL(valueChanged ( int )), this, SLOT(scroll_view( int  )) );



	QObject::connect(QCheckBox_3, SIGNAL(toggled (bool)), this, SLOT(toggle_ns_menu(bool)) );
	QObject::connect(QCheckBox_2, SIGNAL(toggled (bool)), this, SLOT(toggle_stat_menu(bool)) );
	QObject::connect(QCheckBox_4, SIGNAL(toggled (bool)), this, SLOT(toggle_load_menu(bool)) );
	QObject::connect(QCheckBox_1, SIGNAL(toggled (bool)), this, SLOT(toggle_proc_menu(bool)) );




}







void MosixviewApp::getconfig() {

	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

 	QPixmap host;
	host= QPixmap(hosti_g);


	 int character='#';
	const char *hostname;
	const char *range;
	char *sub_string1=new char[50];
	char *hostnametmp=new char[50];
	char *new_last_bit=new char[5];
	int lang=0;
	int howmany=0;
	int p=0;
	int lastbit=0;
	int lang_lastbit=0;
	int lang_hostname=0;
	int lang_oldbit=0;
	int new_host_lang=0;
	char *host_ohne_bit=new char[50];
	int second=0;


	int labelheight=0;
	char hostnr[5];
	int current_h=0;
	int current_range=0;
	int current_label52_h=0;
	int current_label50_h=0;
	int current_label110_h=0;
	int current_label111_h=0;
	int current_refresh=0;
	int current_auto_refresh=0;
	int current_ns_box=0;
	int current_load_box=0;




	QFile fp("/etc/mosix.map");

	if ( fp.open(IO_ReadOnly) ) {    // file opened successfully
		QTextStream t( &fp );        // use a text stream
		QString s;
		int n = 0;
		while ( !t.eof() ) {        // until end of file...


			s = t.readLine();       // line of text excluding '\n'
			s = s.simplifyWhiteSpace();

if ( (s.find ( character, 0, TRUE )==-1)&&(s.length()>1) ) {

	second=	s.find ( 32, 0, TRUE );
	lang=	s.findRev ( 32, s.length(), TRUE );
	range=(const char *)s+(lang+1);


if ( (strcmp(range, "0"))||(strcmp(range, "ALIAS")) ) {


	howmany=atoi(range);

	if (howmany!=1){

	s.truncate( lang );
	hostname=(const char *)s+(second+1);


	for (p=0; p<howmany; p++) {

	n++;

	strcpy(hostnametmp, hostname);

  strtok((char *)hostnametmp, ".");
	sub_string1=strtok(NULL, ".");
	sub_string1=strtok(NULL, ".");
	sub_string1=strtok(NULL, ".");

	lastbit=atoi(sub_string1);

	sprintf(new_last_bit, "%d", lastbit+p);

	lang_oldbit=strlen(sub_string1);

	lang_lastbit=strlen(new_last_bit);
	lang_hostname=strlen(hostname);

	new_host_lang=lang_hostname-lang_oldbit;

	strncpy(host_ohne_bit, hostname, new_host_lang);

	host_ohne_bit[new_host_lang-1] = '.';
	host_ohne_bit[new_host_lang] = '\0';

	char *real_host=new char[strlen(host_ohne_bit)+lang_lastbit];
	strcpy(real_host, host_ohne_bit);
	strcat(real_host, new_last_bit);
	real_host[strlen(host_ohne_bit)+lang_lastbit] = '\0';



	labelheight=(n+1)*20;
	sprintf(hostnr, "%d", n);

  QLabel_stat[n]= new QLabel(QGroupBox_1,"NoName");
  QLabel_stat[n]->setGeometry(5,labelheight,25,20);
  QLabel_stat[n]->setMinimumSize(0,0);
  QLabel_stat[n]->setFont(QFont("helvetica", 12, 50));
  QLabel_stat[n]->setBackgroundPixmap(QPixmap(white_pix));
  QLabel_stat[n]->setText(hostnr);
  QLabel_stat[n]->setMargin(0);
  QLabel_stat[n]->setAlignment( AlignVCenter | AlignCenter );
  QLabel_stat[n]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	QWhatsThis::add(QLabel_stat[n] ,"This box shows the status of the MOSIX-node. Green for avaiable, red for down.\n");

  QPushButton_host[n]= new QPushButton(host, real_host, QGroupBox_1);
  QPushButton_host[n]->setName(real_host);;
  QPushButton_host[n]->setGeometry(30,labelheight,120,20);
	QPushButton_host[n]->setMinimumSize(0,0);
	QPushButton_host[n]->setText(real_host);

	QObject::connect( 	QPushButton_host[n], SIGNAL(clicked()), this, SLOT( neuwin1()) );
	QWhatsThis::add(QPushButton_host[n] ,"Click to configure this node You can execute the most common mosctl-command or stop/start mosix.\n");


  QSlider_host[n]= new QSlider(QGroupBox_1,real_host);
  QSlider_host[n]->setGeometry(150,labelheight,110,20);
  QSlider_host[n]->setMinimumSize(0,0);
  QSlider_host[n]->setValue(0);
  QSlider_host[n]->setRange(0,100000);
  QSlider_host[n]->setTickInterval ( 10000 );
  QSlider_host[n]->setTickmarks ( QSlider::Below );
  QSlider_host[n]->setOrientation(QSlider::Horizontal);

	QObject::connect(  QSlider_host[n], SIGNAL(valueChanged(int)), this, SLOT(setspeed(int)) );
	QWhatsThis::add(QSlider_host[n] ,"Change the speed+priority of this host in your cluster. Processes will easier migrate to a node with a higher speed-value.\n");

	QLCDNumber_host[n]= new QLCDNumber(QGroupBox_1, real_host);
	QLCDNumber_host[n]->setGeometry(260,labelheight,50,20);
	QLCDNumber_host[n]->setMinimumSize(0,0);
	QLCDNumber_host[n]->display("0");
	QLCDNumber_host[n]->setNumDigits(6);
	QLCDNumber_host[n]->setSegmentStyle (QLCDNumber::Flat);

	QObject::connect(  QSlider_host[n], SIGNAL(valueChanged(int)),   QLCDNumber_host[n], SLOT(display(int)) );
	QWhatsThis::add(QLCDNumber_host[n] ,"The LCD-number shows the current MOSIX-speed of this host.\n");


	QProgressBar_host[n]= new QProgressBar(QGroupBox_1, real_host);
	QProgressBar_host[n]->setGeometry(310,labelheight,130,20);
	QProgressBar_host[n]->setMinimumSize(0,0);
	QProgressBar_host[n]->setTotalSteps (150);
	QWhatsThis::add(QProgressBar_host[n] ,"These progressbars gives you an overview of the load on your cluster.\n");


	current_h=QGroupBox_1->height();
	current_h=current_h+20;
	QGroupBox_1->setGeometry ( 20, 55, 450, current_h );


	current_range=QScrollBar_1->maxValue ();
	current_range=current_range+20;
	QScrollBar_1->setRange ( 0, current_range );

	current_label52_h=QLabel_52->y();
	current_label52_h=current_label52_h+20;
	QLabel_52->setGeometry ( 10, current_label52_h, 130, 20 );

	current_label50_h=QLabel_50->y();
	current_label50_h=current_label50_h+20;
	QLabel_50->setGeometry ( 140, current_label50_h, 60, 20 );


	current_label110_h=QLabel_110->y();
	current_label110_h=current_label110_h+20;
	QLabel_110->setGeometry ( 10, current_label110_h, 80, 20 );

	current_label111_h=QLabel_111->y();
	current_label111_h=current_label111_h+20;
	QLabel_111->setGeometry ( 140, current_label111_h, 300, 20 );

	current_refresh=QPushButton_73->y();
	current_refresh=current_refresh+20;
	QPushButton_73->setGeometry(5,current_refresh,65,20);

	current_auto_refresh=QCheckBox_2->y();
	current_auto_refresh=current_auto_refresh+20;
	QCheckBox_2->setGeometry(80,current_auto_refresh,140,20);

	current_ns_box=QCheckBox_3->y();
	current_ns_box=current_ns_box+20;
	QCheckBox_3->setGeometry(80,current_ns_box,220,20);

	current_load_box=QCheckBox_4->y();
	current_load_box=current_load_box+20;
	QCheckBox_4->setGeometry(320,current_load_box,120,20);




 delete real_host;

 																}

	} else {





	n++;

	s.truncate( lang );

	hostname=(const char *)s+(second+1);

	labelheight=(n+1)*20;
	sprintf(hostnr, "%d", n);

  QLabel_stat[n]= new QLabel(QGroupBox_1,"NoName");
  QLabel_stat[n]->setGeometry(5,labelheight,25,20);
  QLabel_stat[n]->setMinimumSize(0,0);
  QLabel_stat[n]->setFont(QFont("helvetica", 12, 50));
  QLabel_stat[n]->setBackgroundPixmap(QPixmap(white_pix));
  QLabel_stat[n]->setText(hostnr);
  QLabel_stat[n]->setMargin(0);
  QLabel_stat[n]->setAlignment( AlignVCenter | AlignCenter );
  QLabel_stat[n]->setFrameStyle( QFrame::Panel | QFrame::Sunken );

	QWhatsThis::add(QLabel_stat[n] ,"This box shows the status of the MOSIX-node. Green for avaiable, red for down.\n");

  QPushButton_host[n]= new QPushButton(host, hostname, QGroupBox_1);
  QPushButton_host[n]->setName(hostname);
  QPushButton_host[n]->setGeometry(30,labelheight,120,20);
	QPushButton_host[n]->setMinimumSize(0,0);
	QPushButton_host[n]->setText(hostname);

	QObject::connect( 	QPushButton_host[n], SIGNAL(clicked()), this, SLOT( neuwin1()) );
	QWhatsThis::add(QPushButton_host[n] ,"Click to configure this node You can execute the most common mosctl-command or stop/start mosix.\n");

  QSlider_host[n]= new QSlider(QGroupBox_1,hostname);
  QSlider_host[n]->setGeometry(150,labelheight,110,20);
  QSlider_host[n]->setMinimumSize(0,0);
  QSlider_host[n]->setValue(0);
  QSlider_host[n]->setRange(0,100000);
  QSlider_host[n]->setTickInterval ( 10000 );
  QSlider_host[n]->setTickmarks ( QSlider::Below );
  QSlider_host[n]->setOrientation(QSlider::Horizontal);

	QObject::connect(  QSlider_host[n], SIGNAL(valueChanged(int)), this, SLOT(setspeed(int)) );
	QWhatsThis::add(QSlider_host[n] ,"Change the speed+priority of this host in your cluster. Processes will easier migrate to a node with a higher speed-value.\n");

	QLCDNumber_host[n]= new QLCDNumber(QGroupBox_1, hostname);
	QLCDNumber_host[n]->setGeometry(260,labelheight,50,20);
	QLCDNumber_host[n]->setMinimumSize(0,0);
	QLCDNumber_host[n]->display("0");
	QLCDNumber_host[n]->setNumDigits(6);
	QLCDNumber_host[n]->setSegmentStyle (QLCDNumber::Flat);

	QObject::connect(  QSlider_host[n], SIGNAL(valueChanged(int)),   QLCDNumber_host[n], SLOT(display(int)) );
	QWhatsThis::add(QLCDNumber_host[n] ,"The LCD-number shows the current MOSIX-speed of this host.\n");

	QProgressBar_host[n]= new QProgressBar(QGroupBox_1, hostname);
	QProgressBar_host[n]->setGeometry(310,labelheight,130,20);
	QProgressBar_host[n]->setMinimumSize(0,0);
	QProgressBar_host[n]->setTotalSteps (150);
	QWhatsThis::add(QProgressBar_host[n] ,"These progressbars gives you an overview of the load on your cluster.\n");


	current_h=QGroupBox_1->height();
	current_h=current_h+20;
	QGroupBox_1->setGeometry ( 20, 55, 450, current_h );


	current_range=QScrollBar_1->maxValue ();
	current_range=current_range+20;
	QScrollBar_1->setRange ( 0, current_range );

	current_label52_h=QLabel_52->y();
	current_label52_h=current_label52_h+20;
	QLabel_52->setGeometry ( 10, current_label52_h, 130, 20 );

	current_label50_h=QLabel_50->y();
	current_label50_h=current_label50_h+20;
	QLabel_50->setGeometry ( 140, current_label50_h, 60, 20 );


	current_label110_h=QLabel_110->y();
	current_label110_h=current_label110_h+20;
	QLabel_110->setGeometry ( 10, current_label110_h, 80, 20 );

	current_label111_h=QLabel_111->y();
	current_label111_h=current_label111_h+20;
	QLabel_111->setGeometry ( 140, current_label111_h, 300, 20 );

	current_refresh=QPushButton_73->y();
	current_refresh=current_refresh+20;
	QPushButton_73->setGeometry(5,current_refresh,65,20);

	current_auto_refresh=QCheckBox_2->y();
	current_auto_refresh=current_auto_refresh+20;
	QCheckBox_2->setGeometry(80,current_auto_refresh,140,20);

	current_ns_box=QCheckBox_3->y();
	current_ns_box=current_ns_box+20;
	QCheckBox_3->setGeometry(80,current_ns_box,220,20);

	current_load_box=QCheckBox_4->y();
	current_load_box=current_load_box+20;
	QCheckBox_4->setGeometry(320,current_load_box,120,20);



          }


	}






                                   }
			}
		fp.close();
	}





}











void MosixviewApp::typval() {

	int status=0;
	int nummerint=0;
	FILE *zahl;
  char fspeed[100];
	char cstatus[4];
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;


	if(QCheckBox_4->isChecked()) {


	if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {
										howmany++;
										}
										howmany--;

		}
	closedir(dir);


	for (status=0;status<howmany;status++) {
	
	sprintf(cstatus, "%d", status);	
	strcpy(fspeed, "");
	strcpy(fspeed, "/proc/mosix/nodes/");
	strcat(fspeed, cstatus);
	strcat(fspeed, "/load");

	if((zahl=fopen(fspeed, "r")) == NULL) {
        } else {
	        fscanf(zahl, "%d", &nummerint);
				if (nummerint!=-101) {
					if (nummerint<QProgressBar_host[status]->progress()) {
					QProgressBar_host[status]->reset ();
					QProgressBar_host[status]->setProgress(nummerint);
					} else {
					QProgressBar_host[status]->setProgress(nummerint);
							}
					}
		fclose(zahl);
		}
	}


		}

}











void MosixviewApp::getval() {

	int status=0;
	int nummerint=0;
	FILE *zahl;
  char fspeed[100];
	char cstatus[4];
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;


	if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {
										howmany++;
										}
										howmany--;

		}
	closedir(dir);


	for (status=0;status<howmany;status++) {
	
	sprintf(cstatus, "%d", status);	
	strcpy(fspeed, "");
	strcpy(fspeed, "/proc/mosix/nodes/");
	strcat(fspeed, cstatus);
	strcat(fspeed, "/speed");

	if((zahl=fopen(fspeed, "r")) == NULL) {
        } else {
	        fscanf(zahl, "%d", &nummerint);
				if(nummerint<0) { nummerint=0; }
					QSlider_host[status]->setValue(nummerint);
					QLCDNumber_host[status]->display(nummerint);

		fclose(zahl);
		}
	}


}





void MosixviewApp::setspeed(int speed) {

	char mosspeed[6]="";
	char setsp[100]="";
	char outp[100]="";
	int error;
	const  char *hostname;
	const QObject *button = sender();

	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	if (speed<0) {
  	speed=0;
	}

	sprintf(mosspeed, "%d", speed);

	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl setspeed ");
	strcat(setsp, mosspeed);

	if((error=system(setsp)) > 0) {
        printf("cannot set mosspeed\n");

	strcpy(outp, "cannot set speed to ");
	strcat(outp, mosspeed);
	strcat(outp, " on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        } else {

	strcpy(outp, "set speed to ");
	strcat(outp, mosspeed);
	strcat(outp, " on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

                }




}













void MosixviewApp::action_stop() {

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);


	hostname=button->name();

	QPushButton_90-> setToggleButton ( TRUE );
	QPushButton_90-> toggle();
	QPushButton_80-> toggle ();
	QPushButton_80-> setToggleButton ( FALSE );

	strcpy(outp, "stopping mosix on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

 	QFile map("/etc/rc.d/init.d/mosix");
  if (map.exists()) {

	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /etc/rc.d/init.d/mosix stop");

	} else {

	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /etc/init.d/mosix stop");

	}

	if((error=system(setsp)) > 0) {
        printf("cannot stop mosix\n");

				strcpy(outp, "cannot stop mosix on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }


}







void MosixviewApp::action_start() {

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	QPushButton_80-> setToggleButton ( TRUE );
	QPushButton_80-> toggle();
	QPushButton_90-> toggle ();
	QPushButton_90-> setToggleButton ( FALSE );

	strcpy(outp, "starting mosix on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));



 	QFile map("/etc/rc.d/init.d/mosix");
  if (map.exists()) {

	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /etc/rc.d/init.d/mosix start");

	} else {

	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /etc/init.d/mosix start");

	}





	if((error=system(setsp)) > 0) {
        printf("cannot start mosix\n");

				strcpy(outp, "cannot start mosix on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }


}












void MosixviewApp::action_lstay(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	QPushButton_30-> setToggleButton ( TRUE );
	QPushButton_30-> toggle();
	QPushButton_40-> toggle ();
	QPushButton_40-> setToggleButton ( FALSE );

	strcpy(outp, "local processes return to ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl bring");
	if((error=system(setsp)) > 0) {
        printf("cannot set -lstay\n");

				strcpy(outp, "cannot return local processes to ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }

}





void MosixviewApp::action_nolstay(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	QPushButton_40-> setToggleButton ( TRUE );
	QPushButton_40-> toggle();
	QPushButton_30-> toggle ();
	QPushButton_30-> setToggleButton ( FALSE );

	strcpy(outp, "local processes can migrate on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));




	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl -lstay");
	if((error=system(setsp)) > 0) {
        printf("cannot set -lstay\n");

				strcpy(outp, "allowing local processes to migrate failed on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }

}





void MosixviewApp::action_migration(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	QPushButton_2->setToggleButton ( TRUE );
	QPushButton_2->toggle();
	QPushButton_12->toggle ();
	QPushButton_12->setToggleButton ( FALSE );

	strcpy(outp, "auto-migration enabled for ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl -stay");
	if((error=system(setsp)) > 0) {
        printf("cannot set -stay\n");

				strcpy(outp, "failed to set auto-migration enabled for ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }


}





void MosixviewApp::action_nomigration(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	QPushButton_12-> setToggleButton ( TRUE );
	QPushButton_12-> toggle ();
	QPushButton_2-> toggle();
	QPushButton_2-> setToggleButton ( FALSE );

	strcpy(outp, "auto-migration disabled for ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl stay");
	if((error=system(setsp)) > 0) {
        printf("cannot set stay\n");
	
				strcpy(outp, "failed to disable auto-migration on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }


}








void MosixviewApp::action_block(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	QPushButton_50-> setToggleButton ( TRUE );
	QPushButton_50-> toggle();
	QPushButton_60-> toggle ();
	QPushButton_60-> setToggleButton ( FALSE );

	strcpy(outp, "blocking enabled for ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl expel");
	if((error=system(setsp)) > 0) {
        printf("cannot set expel\n");

				strcpy(outp, "failed to set blocking enabled for ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }

}






void MosixviewApp::action_noblock(){

	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	QPushButton_60-> setToggleButton ( TRUE );
	QPushButton_60-> toggle();
	QPushButton_50-> toggle ();
	QPushButton_50-> setToggleButton ( FALSE );

	strcpy(outp, "blocking disabled for ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl -block");
	if((error=system(setsp)) > 0) {
        printf("cannot set -block\n");

				strcpy(outp, "failed to set blocking disabled for ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));
        }


}




void MosixviewApp::action_noquiet(){


	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	QPushButton_91-> setToggleButton ( TRUE );
	QPushButton_91-> toggle();
	QPushButton_81-> toggle ();
	QPushButton_81-> setToggleButton ( FALSE );

	strcpy(outp, "auto load-dissemination stopped on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl quiet");
	if((error=system(setsp)) > 0) {
        printf("cannot set quiet\n");

				strcpy(outp, "failed to execute mosctl quiet on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }

}






void MosixviewApp::action_quiet(){



	char setsp[100]="";
	char outp[100]="";

	int error;
	const char *hostname;
	const QObject *button = sender();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	hostname=button->name();

	QPushButton_81-> setToggleButton ( TRUE );
	QPushButton_81-> toggle();
	QPushButton_91-> toggle ();
	QPushButton_91-> setToggleButton ( FALSE );

	strcpy(outp, "auto load-dissemination resumed on ");
	strcat(outp, hostname);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));



	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosctl -quiet");
	if((error=system(setsp)) > 0) {
        printf("cannot execute mosctl -quiet\n");

				strcpy(outp, "failed to execute mosctl -quiet on ");
				strcat(outp, hostname);
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));
        }


}













void MosixviewApp::neuwin1() {

	const  char *hostname;
	const  char *hostname2;
	const QObject *button = sender();

	struct in_addr **ip;
	struct in_addr num;
	struct hostent *host;
	char ipaddr[20];

	QPixmap white_pix, conf, end, migrat;
	white_pix= QPixmap(white_xpm);
	conf = QPixmap(config);
	end = QPixmap(ende);
	migrat= QPixmap(migrator);



	hostname=button->name();

	hinten1= new QWidget(0, hostname);
	hinten1->setGeometry(50,30,50,110);
	hinten1->setMinimumSize(0,0);
	hinten1->resize(250, 250);

	QGroupBox *backr = new QGroupBox("",hinten1);
	backr->setGeometry(5, 30, 245,215);
	backr->setMinimumSize(0,0);
	backr->resize(240, 210);


  QPushButton_2= new QPushButton(backr,hostname);
  QPushButton_2->setGeometry(10,70,40,20);
  QPushButton_2->setMinimumSize(0,0);
  QPushButton_2->setText("on");
  QWhatsThis::add(QPushButton_2,"Click this button to enable\nauto-migration for this host.\n");
	QObject::connect(   QPushButton_2, SIGNAL(clicked()), this, SLOT( action_migration()) );


  QPushButton_12= new QPushButton(backr,hostname);
  QPushButton_12->setGeometry(50,70,40,20);
  QPushButton_12->setMinimumSize(0,0);
  QPushButton_12->setText("off");
  QWhatsThis::add(QPushButton_12,"Click this button to disable\nauto-migration for this host.\n");
	QObject::connect(   QPushButton_12, SIGNAL(clicked()), this, SLOT( action_nomigration()) );

  QPushButton_81= new QPushButton(backr,hostname);
  QPushButton_81->setGeometry(10,90,40,20);
  QPushButton_81->setMinimumSize(0,0);
  QPushButton_81->setText("yes");
	QObject::connect( QPushButton_81, SIGNAL(clicked()), this, SLOT( action_quiet()) );

	QPushButton_91= new QPushButton(backr,hostname);
  QPushButton_91->setGeometry(50,90,40,20);
  QPushButton_91->setMinimumSize(0,0);
  QPushButton_91->setText("no");
	QObject::connect( QPushButton_91, SIGNAL(clicked()), this, SLOT( action_noquiet()) );

  QPushButton_30= new QPushButton(backr,hostname);
  QPushButton_30->setGeometry(10,110,40,20);
  QPushButton_30->setMinimumSize(0,0);
  QPushButton_30->setText("yes");
	QObject::connect(   QPushButton_30, SIGNAL(clicked()), this, SLOT( action_lstay()) );

  QPushButton_40= new QPushButton(backr,hostname);
  QPushButton_40->setGeometry(50,110,40,20);
  QPushButton_40->setMinimumSize(0,0);
  QPushButton_40->setText("no");
	QObject::connect(   QPushButton_40, SIGNAL(clicked()), this, SLOT( action_nolstay()) );

  QPushButton_50= new QPushButton(backr,hostname);
  QPushButton_50->setGeometry(10,130,40,20);
  QPushButton_50->setMinimumSize(0,0);
  QPushButton_50->setText("yes");
	QObject::connect(   QPushButton_50, SIGNAL(clicked()), this, SLOT( action_block()) );

  QPushButton_60= new QPushButton(backr,hostname);
  QPushButton_60->setGeometry(50,130,40,20);
  QPushButton_60->setMinimumSize(0,0);
  QPushButton_60->setText("no");
	QObject::connect(   QPushButton_60, SIGNAL(clicked()), this, SLOT( action_noblock()) );

  QPushButton_80= new QPushButton(backr,hostname);
  QPushButton_80->setGeometry(10,150,40,20);
  QPushButton_80->setMinimumSize(0,0);
  QPushButton_80->setText("start");
	QObject::connect( QPushButton_80, SIGNAL(clicked()), this, SLOT( action_start()) );


	QPushButton_90= new QPushButton(backr,hostname);
  QPushButton_90->setGeometry(50,150,40,20);
  QPushButton_90->setMinimumSize(0,0);
  QPushButton_90->setText("stop");
	QObject::connect( QPushButton_90, SIGNAL(clicked()), this, SLOT( action_stop()) );

  QPushButton_14= new QPushButton(end, hostname, backr);
  QPushButton_14->setGeometry(170,180,60,20);
  QPushButton_14->setMinimumSize(0,0);
  QPushButton_14->setText("close");
  QWhatsThis::add(QPushButton_14,"Close MOSIX-configuration\n");

	QObject::connect( QPushButton_14, SIGNAL(clicked()), hinten1, SLOT( close()) );


  proc_remotebox= new QPushButton(migrat, hostname, backr);
  proc_remotebox->setGeometry(10,180,125,20);
  proc_remotebox->setMinimumSize(0,0);
  proc_remotebox->setText("remote proc-box");
  proc_remotebox->setName(hostname);
  QWhatsThis::add(proc_remotebox,"Open a remote process box\n");

	QObject::connect( proc_remotebox, SIGNAL(clicked()), this, SLOT( open_remoteprocs()) );



  QLabel_hostconf5= new QLabel(hinten1,hostname);
  QLabel_hostconf5->setGeometry(30,10,200,20);
  QLabel_hostconf5->setMinimumSize(0,0);
  QLabel_hostconf5->setText("MOSIX-configuration");
  QLabel_hostconf5->setMargin(2);


  QLabel_conficon= new QLabel(hinten1,hostname);
  QLabel_conficon->setGeometry(10,10,20,20);
  QLabel_conficon->setMinimumSize(0,0);
  QLabel_conficon->setPixmap(conf);



	if(QCheckBox_3->isChecked()) {

  QLabel_hostconf8= new QLabel(hinten1,hostname);
  QLabel_hostconf8->setGeometry(15,40,80,20);
  QLabel_hostconf8->setMinimumSize(0,0);
  QLabel_hostconf8->setText("hostname:");
  QLabel_hostconf8->setMargin(2);

  QLabel_hostconf9= new QLabel(hinten1,hostname);
  QLabel_hostconf9->setGeometry(15,65,80,20);
  QLabel_hostconf9->setMinimumSize(0,0);
  QLabel_hostconf9->setText("ip-address:");
  QLabel_hostconf9->setMargin(2);

  QLabel_hostconf= new QLabel(hinten1,hostname);
  QLabel_hostconf->setGeometry(100,40,120,20);
  QLabel_hostconf->setMinimumSize(0,0);
  QLabel_hostconf->setMargin(2);
  QLabel_hostconf->setFrameStyle( QFrame::Panel | QFrame::Sunken );


  QLabel_hostconf7= new QLabel(hinten1,hostname);
  QLabel_hostconf7->setGeometry(100,65,120,20);
  QLabel_hostconf7->setMinimumSize(0,0);
  QLabel_hostconf7->setMargin(2);
  QLabel_hostconf7->setFrameStyle( QFrame::Panel | QFrame::Sunken );

		} else {

  QLabel_hostconf8= new QLabel(hinten1,hostname);
  QLabel_hostconf8->setGeometry(15,60,80,20);
  QLabel_hostconf8->setMinimumSize(0,0);
  QLabel_hostconf8->setText("mosix-node:");
  QLabel_hostconf8->setMargin(2);

  QLabel_hostconf= new QLabel(hinten1,hostname);
  QLabel_hostconf->setGeometry(100,60,120,20);
  QLabel_hostconf->setMinimumSize(0,0);
  QLabel_hostconf->setMargin(2);
  QLabel_hostconf->setFrameStyle( QFrame::Panel | QFrame::Sunken );
  QLabel_hostconf->setText(hostname);
  QLabel_hostconf->setBackgroundPixmap(QPixmap(white_pix));
		}




  QLabel_hostconf1= new QLabel(hinten1,"conf1");
  QLabel_hostconf1->setGeometry(100,100,140,20);
  QLabel_hostconf1->setMinimumSize(0,0);
  QLabel_hostconf1->setText("auto-migration on/off");
  QLabel_hostconf1->setMargin(2);

  QLabel_hostconf6= new QLabel(hinten1,"quiet");
  QLabel_hostconf6->setGeometry(100,120,140,20);
  QLabel_hostconf6->setMinimumSize(0,0);
  QLabel_hostconf6->setText("talk to others nodes");
  QLabel_hostconf6->setMargin(2);

  QLabel_hostconf2= new QLabel(hinten1,"conf2");
  QLabel_hostconf2->setGeometry(100,140,140,20);
  QLabel_hostconf2->setMinimumSize(0,0);
  QLabel_hostconf2->setText("local procs stay");
  QLabel_hostconf2->setMargin(2);

  QLabel_hostconf3= new QLabel(hinten1,"conf3");
  QLabel_hostconf3->setGeometry(100,160,140,20);
  QLabel_hostconf3->setMinimumSize(0,0);
  QLabel_hostconf3->setText("send away guest procs");
  QLabel_hostconf3->setMargin(2);

  QLabel_hostconf4= new QLabel(hinten1,"conf4");
  QLabel_hostconf4->setGeometry(100,180,140,20);
  QLabel_hostconf4->setMinimumSize(0,0);
  QLabel_hostconf4->setText("MOSIX start/stop");
  QLabel_hostconf4->setMargin(2);

	hinten1->show();


	if(QCheckBox_3->isChecked()) {

if (inet_aton(hostname, &num)!=0) {

        host=gethostbyaddr((char*)&num, sizeof(num), AF_INET);
        ip=(struct in_addr**)host->h_addr_list;
				hostname2=host->h_name;

			  QLabel_hostconf->setText(hostname2);
			  QLabel_hostconf->setBackgroundPixmap(QPixmap(white_pix));
			  QLabel_hostconf7->setText(hostname);
			  QLabel_hostconf7->setBackgroundPixmap(QPixmap(white_pix));

        } else {

        host=gethostbyname(hostname);
        ip=(struct in_addr**)host->h_addr_list;
				sprintf(ipaddr, "%s",inet_ntoa(**ip));

			  QLabel_hostconf->setText(hostname);
			  QLabel_hostconf->setBackgroundPixmap(QPixmap(white_pix));
			  QLabel_hostconf7->setText(ipaddr);
			  QLabel_hostconf7->setBackgroundPixmap(QPixmap(white_pix));

        }


		} else {



					}

}



	void MosixviewApp::close_config() {

	delete hinten1;
}




	void MosixviewApp::closehostbox() {

	delete hinten;
}





	void MosixviewApp::mosixstatus() {

	int status=0;
	int nummerint=0;
	FILE *zahl;
  char fspeed[100];
	char cstatus[4];
	DIR *dir;
	struct dirent *dir_info;
	int howmany=0;


 	QPixmap green_pix;
	green_pix= QPixmap(green_xpm);

 	QPixmap red_pix;
	red_pix= QPixmap(red_xpm);


	if ((dir=opendir("/proc/mosix/nodes"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {
										howmany++;
										}
										howmany--;
		}
		closedir(dir);


	for (status=0;status<howmany;status++) {
	
	sprintf(cstatus, "%d", status);	
	strcpy(fspeed, "");
	strcpy(fspeed, "/proc/mosix/nodes/");
	strcat(fspeed, cstatus);
	strcat(fspeed, "/speed");

	if((zahl=fopen(fspeed, "r")) == NULL) {
        } else {
	        fscanf(zahl, "%d", &nummerint);
				if(nummerint>=2) {
							QLabel_stat[status]->setBackgroundPixmap(QPixmap(green_pix));
											 } else {
							QLabel_stat[status]->setBackgroundPixmap(QPixmap(red_pix));
												}
		fclose(zahl);
		}
	}

}





	void MosixviewApp::labelconf() {



QLabel_50->setFrameStyle( QFrame::Panel | QFrame::Sunken );
QLabel_50->setAlignment( AlignVCenter | AlignRight );


QLabel_111->setFrameStyle( QFrame::Panel | QFrame::Sunken );


QScrollBar_1->setSteps ( 60,320 );





QWhatsThis::add(QPushButton_70,"To refresh the processbox manualy click this button.\n");
QWhatsThis::add(QCheckBox_1,"If checked the processbox refreshs automaticaly.\n");

QWhatsThis::add(QLabel_50,"Contains the PID of the last-managed process.\n");
QWhatsThis::add(QLabel_111,"This box shows the output of the MOSIX-commands.\n");



QWhatsThis::add(this,"Control your MOSIX-Cluster with MOSIXVIEW.\nThis GUI will help you manage the configuration, load and process-migration.\n");

}






	void MosixviewApp::refreshit() {

	if(QCheckBox_1->isChecked()) {
		fill_procbox();
		}

}



	void MosixviewApp::refreshitmanual() {

		fill_procbox();

}




	void MosixviewApp::refreshit_status() {

	if(QCheckBox_2->isChecked()) {
		mosixstatus();
		}

	}



	void MosixviewApp::refreshit_status_manual() {
		mosixstatus();
	}







	void MosixviewApp::killproc() {

	char killprocnr[50];
	char outp[100]="";
	int error;
	const char *cproc;
	const QObject *button = sender();

	cproc=button->name();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	strcpy(killprocnr, "");
	strcpy(killprocnr, "/bin/kill ");
	strcat(killprocnr, cproc);
	if((error=system(killprocnr)) > 0) {
        printf("cannot kill proc\n");
	strcpy(outp, "cannot kill PID ");
	strcat(outp, cproc);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }

	strcpy(outp, "killed PID ");
	strcat(outp, cproc);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

//	hinten->close();

}








void MosixviewApp::neuwin(){

	processbox = new QListView(this);
	processbox->setGeometry(470,60,50,100);
	processbox->setMinimumSize(0,0);
	processbox->setAllColumnsShowFocus(1);
	processbox->addColumn("pid");
	processbox->addColumn("n#");
	processbox->addColumn("stat");
	processbox->addColumn("cmdline");


	processbox->setSorting(2, TRUE);

	processbox->setColumnAlignment (0, AlignLeft);
	processbox->setColumnAlignment (1, AlignLeft);
	processbox->setColumnAlignment (2, AlignLeft);
	processbox->setItemMargin(2);
	processbox->resize(190, 300);
	fill_procbox();
	processbox->show();
	QObject::connect( processbox, SIGNAL(doubleClicked(QListViewItem *)), this, SLOT( labelit( QListViewItem *)) );


  QWhatsThis::add(processbox,"This box shows the running processes.\nThe number in the column n# is the MOSIX-node\nthe process is running on.\n(0 is this host)\nDoubleclick a process to migrate it!");



}



	void MosixviewApp::labelit( QListViewItem *index) {

 int character='#';
	const char *hostname;
	const char *range;
	char *sub_string1=new char[50];
	char *hostnametmp=new char[50];
	char *new_last_bit=new char[5];
	int lang=0;
	int howmany=0;
	int p=0;
	int lastbit=0;
	int lang_lastbit=0;
	int lang_hostname=0;
	int lang_oldbit=0;
	int new_host_lang=0;
	char *host_ohne_bit=new char[50];
	int second=0;

	char output[250];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

 	QPixmap host, migrat, home, smile, killit, end;
	host= QPixmap(hosti);
	migrat= QPixmap(migrator);
	home= QPixmap(gohome);
	smile = QPixmap(speed);
	killit = QPixmap(kill);
	end = QPixmap(ende);


	hinten = new QWidget(0, "");
	hinten->setGeometry(640,300,50,110);
	hinten->setMinimumSize(0,0);
	hinten->resize(170, 285);

	QGroupBox *backr2 = new QGroupBox("",hinten);
	backr2->setGeometry(5,25,50,130);
	backr2->setMinimumSize(0,0);
	backr2->resize(160, 255);

	QLabel *QLabel_proc = new QLabel("",backr2);
	QLabel_proc->setGeometry(10,90,20,30);
	QLabel_proc->setMinimumSize(0,0);
	QLabel_proc->resize(140, 100);

	QListBox *hostbox = new QListBox(hinten);
	hostbox->setGeometry(10,30,50,110);
	hostbox->setMinimumSize(0,0);
	hostbox->resize(150, 100);



	QFile fp("/etc/mosix.map");

	if ( fp.open(IO_ReadOnly) ) {    // file opened successfully
		QTextStream t( &fp );        // use a text stream
		QString s;
		int n = 0;
		while ( !t.eof() ) {        // until end of file...


			s = t.readLine();       // line of text excluding '\n'
			s = s.simplifyWhiteSpace();

if ( (s.find ( character, 0, TRUE )==-1)&&(s.length()>1) ) {

	second=	s.find ( 32, 0, TRUE );
	lang=	s.findRev ( 32, s.length(), TRUE );
	range=(const char *)s+(lang+1);


if ( (strcmp(range, "0"))||(strcmp(range, "ALIAS")) ) {


	howmany=atoi(range);

	if (howmany!=1){

	s.truncate( lang );
	hostname=(const char *)s+(second+1);

	for (p=0; p<howmany; p++) {

	n++;

	strcpy(hostnametmp, hostname);

  strtok((char *)hostnametmp, ".");
	sub_string1=strtok(NULL, ".");
	sub_string1=strtok(NULL, ".");
	sub_string1=strtok(NULL, ".");

	lastbit=atoi(sub_string1);

	sprintf(new_last_bit, "%d", lastbit+p);

	lang_oldbit=strlen(sub_string1);

	lang_lastbit=strlen(new_last_bit);
	lang_hostname=strlen(hostname);

	new_host_lang=lang_hostname-lang_oldbit;

	strncpy(host_ohne_bit, hostname, new_host_lang);

	host_ohne_bit[new_host_lang-1] = '.';
	host_ohne_bit[new_host_lang] = '\0';

	char *real_host=new char[strlen(host_ohne_bit)+lang_lastbit];
	strcpy(real_host, host_ohne_bit);
	strcat(real_host, new_last_bit);
	real_host[strlen(host_ohne_bit)+lang_lastbit] = '\0';

	hostbox->insertItem(host, real_host, n);

 delete real_host;

 																}

	} else {

	n++;

	s.truncate( lang );

	hostname=(const char *)s+(second+1);

	hostbox->insertItem(host, hostname, n);


          }


	}

                                    }
			}
		fp.close();
	}





	QObject::connect( hostbox, SIGNAL(selected(int)), this, SLOT( migrateto( int )) );

	QLabel_50->setText(index->text(0));
	QLabel_50->setBackgroundPixmap(QPixmap(white_pix));

	strcpy(output, "");
	strcpy(output, "doubleclick a mosix host \nfor migrating the process:\n");
		strcat(output, index->text(0));
		strcat(output, " (");
	strcat(output, index->text(1));
	strcat(output, ")\n");
	QLabel_proc->setText(output);

  QPushButton_71= new QPushButton(end, "close", hinten);
  QPushButton_71->setGeometry(100,255,60,20);
  QPushButton_71->setMinimumSize(0,0);
  QPushButton_71->setText("close");
	QObject::connect( QPushButton_71, SIGNAL(clicked()), hinten, SLOT( close()) );

  QPushButton_home= new QPushButton(home, index->text(0), hinten);
  QPushButton_home->setGeometry(60,185,60,20);
  QPushButton_home->setMinimumSize(0,0);
  QPushButton_home->setText("home");
  QPushButton_home->setName(index->text(0));
	QObject::connect( QPushButton_home, SIGNAL(clicked()), this, SLOT( migratehome()) );

  QPushButton_best= new QPushButton(smile, index->text(0), hinten);
  QPushButton_best->setGeometry(60,205,60,20);
  QPushButton_best->setMinimumSize(0,0);
  QPushButton_best->setText("best");
  QPushButton_best->setName(index->text(0));
	QObject::connect( QPushButton_best, SIGNAL(clicked()), this, SLOT( migratebest()) );

  QPushButton_72= new QPushButton(killit, index->text(0), hinten);
  QPushButton_72->setGeometry(60,225,60,20);
  QPushButton_72->setMinimumSize(0,0);
  QPushButton_72->setText("kill");
  QPushButton_72->setName(index->text(0));
	QObject::connect( QPushButton_72, SIGNAL(clicked()), this, SLOT( killproc()) );


	home_label = new QLabel("",hinten);
	home_label->setGeometry(15,185,40,20);
	home_label->setMinimumSize(0,0);
	home_label->setText("send to");

	best_label = new QLabel("",hinten);
	best_label->setGeometry(15,205,40,20);
	best_label->setMinimumSize(0,0);
	best_label->setText("send to");

	home_label1 = new QLabel("",hinten);
	home_label1->setGeometry(125,185,30,20);
	home_label1->setMinimumSize(0,0);
	home_label1->setText("node");

	best_label1 = new QLabel("",hinten);
	best_label1->setGeometry(125,205,30,20);
	best_label1->setMinimumSize(0,0);
	best_label1->setText("node");

	or_label = new QLabel("",hinten);
	or_label->setGeometry(15,225,40,20);
	or_label->setMinimumSize(0,0);
	or_label->setText("      or");

	proc_label = new QLabel("",hinten);
	proc_label->setGeometry(125,225,30,20);
	proc_label->setMinimumSize(0,0);
	proc_label->setText("proc.");


	proc_titel = new QLabel("",hinten);
	proc_titel->setGeometry(25,5,150,20);
	proc_titel->setMinimumSize(0,0);
	proc_titel->setText("MOSIXVIEW-Migrator");

	pix_titel = new QLabel("",hinten);
	pix_titel->setGeometry(5,5,20,20);
	pix_titel->setMinimumSize(0,0);
	pix_titel->setPixmap(migrat);



	hinten->show();


  QWhatsThis::add(hostbox,"To migrate this process to a specific MOSIX-node\njust doubleclick this host from the hostlist.\n(or kill to kill this process!)");


	}





	void MosixviewApp::migrateto(int index) {

	char setsp[100]="";
	char outp[100]="";
	int error;
	char cindex[5];
	const char *cproc;


 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	cproc=(const char *)QLabel_50->text();



		index++;

		strcpy(cindex, "");
		sprintf(cindex, "%d", index);


	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/migrate ");
	strcat(setsp, cproc);
	strcat(setsp, " ");

	strcat(setsp, cindex);
	if((error=system(setsp)) > 0) {
        printf("cannot migrate PID\n");

	strcpy(outp, "cannot migrate PID ");
	strcat(outp, cproc);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }

	strcpy(outp, "try to migrate PID ");
	strcat(outp, cproc);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));


}









	void MosixviewApp::migratehome() {

	char setsp[100]="";
	char outp[100]="";
	int error;
	const char *cproc;
	const QObject *button = sender();

	cproc=button->name();


 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);


	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/migrate ");
	strcat(setsp, cproc);
	strcat(setsp, " home");

	if((error=system(setsp)) > 0) {
        printf("cannot send PID home\n");

	strcpy(outp, "cannot send home PID ");
	strcat(outp, cproc);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }

	strcpy(outp, "try to send home PID ");
	strcat(outp, cproc);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));


}










	void MosixviewApp::migratebest() {

	char setsp[100]="";
	char outp[100]="";
	int error;
	const char *cproc;
	const QObject *button = sender();

	cproc=button->name();


 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);


	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/migrate ");
	strcat(setsp, cproc);
	strcat(setsp, " balance");

	if((error=system(setsp)) > 0) {
        printf("cannot send PID to best node\n");

	strcpy(outp, "cannot send to best node PID ");
	strcat(outp, cproc);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }

	strcpy(outp, "try to send to best node PID ");
	strcat(outp, cproc);
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));


}


















	void MosixviewApp::fill_procbox() {

	DIR *dir;
	struct dirent *dir_info;
	FILE *fp;
	char cmdline[1000];
	char temp[1000];
	char where[5];
	char stat[1000];


 	QPixmap procicon, remoteprocicon;
	procicon= QPixmap(proc);
	remoteprocicon= QPixmap(proc_remote);

	processbox->clear();

	if ((dir=opendir("/proc"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {


	if((strchr(dir_info->d_name, '1'))||(strchr(dir_info->d_name, '2'))||(strchr(dir_info->d_name, '3'))||(strchr(dir_info->d_name, '4'))||(strchr(dir_info->d_name, '5'))||(strchr(dir_info->d_name, '6'))||(strchr(dir_info->d_name, '7'))||(strchr(dir_info->d_name, '8'))||(strchr(dir_info->d_name, '9')) ) {

        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/cmdline");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s", cmdline);
            fclose(fp);
        }

        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/where");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s", where);
            fclose(fp);
        }



        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/stat");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s", stat);
            fscanf(fp, "%s", stat);
            fscanf(fp, "%s", stat);
            fclose(fp);
        }





		QListViewItem *i1;
		i1 = new QListViewItem(processbox, dir_info->d_name, where, stat, cmdline);

		if (atoi(where)==0) {
		i1->setPixmap(0, procicon);
      } else {
		i1->setPixmap(0, remoteprocicon);
		}



    }

	} //while

closedir(dir);
} //if


}







void MosixviewApp::initActions(){

  QPixmap openIcon, saveIcon, newIcon, help, prem;
  newIcon = QPixmap(filenew);
  openIcon = QPixmap(fileopen);
  saveIcon = QPixmap(filesave);
  saveIcon = QPixmap(filesave);
	help = QPixmap(helpicon);
	prem = QPixmap(remote);

	fileOpen = new QAction(tr("Run program"), openIcon, tr("&Run..."), 0, this);
  fileOpen->setStatusTip(tr("Run a program"));
  fileOpen->setWhatsThis(tr("Run a program"));
  connect(fileOpen, SIGNAL(activated()), this, SLOT(slotFileOpen()));

  fileQuit = new QAction(tr("Exit"), tr("E&xit"), QAccel::stringToKey(tr("Ctrl+Q")), this);
  fileQuit->setStatusTip(tr("Quits the application"));
  fileQuit->setWhatsThis(tr("Exit\n\nQuits the application"));
  connect(fileQuit, SIGNAL(activated()), qApp, SLOT(quit()));

  viewToolBar = new QAction(tr("Toolbar"), tr("Tool&bar"), 0, this, 0, true);
  viewToolBar->setStatusTip(tr("Enables/disables the toolbar"));
  viewToolBar->setWhatsThis(tr("Toolbar\n\nEnables/disables the toolbar"));
  connect(viewToolBar, SIGNAL(toggled(bool)), this, SLOT(slotViewToolBar(bool)));

  viewStatusBar = new QAction(tr("Statusbar"), tr("&Statusbar"), 0, this, 0, true);
  viewStatusBar->setStatusTip(tr("Enables/disables the statusbar"));
  viewStatusBar->setWhatsThis(tr("Statusbar\n\nEnables/disables the statusbar"));
  connect(viewStatusBar, SIGNAL(toggled(bool)), this, SLOT(slotViewStatusBar(bool)));


  helpAboutApp = new QAction(tr("Help"), help,tr("&Help..."), 0, this);
  helpAboutApp->setStatusTip(tr("Help on mosixview"));
  helpAboutApp->setWhatsThis(tr("Help on mosixview"));
  connect(helpAboutApp, SIGNAL(activated()), this, SLOT(slotHelpAbout()));



  remote_action = new QAction(tr("Remote"), prem,tr("&Remote..."), 0, this);
  remote_action->setStatusTip(tr("Manage remote procs running local"));
  remote_action->setWhatsThis(tr("Manage remote procs running local"));
  connect(remote_action, SIGNAL(activated()), this, SLOT(remoteproc()));





}

void MosixviewApp::initMenuBar()
{
  fileMenu=new QPopupMenu();
  fileOpen->addTo(fileMenu);
  fileMenu->insertSeparator();
  fileQuit->addTo(fileMenu);

    confmenu=new QPopupMenu();
    confmenu->setCheckable(true);

    confmenu->insertItem("status", this, SLOT(toggle_config_stat()), 0, ID_STAT);
    confmenu->setItemChecked(ID_CONFIG, false);

    confmenu->insertItem("load", this, SLOT(toggle_config_load()), 0, ID_LOAD);
    confmenu->setItemChecked(ID_LOAD, true);

    confmenu->insertItem("procs", this, SLOT(toggle_config_procs()), 0, ID_PROCS);
    confmenu->setItemChecked(ID_PROCS, true);


    confmenu->insertSeparator();

    confmenu->insertItem("nslookup", this, SLOT(toggle_config_ns()), 0, ID_CONFIG);
    confmenu->setItemChecked(ID_CONFIG, false);





  rem_menu=new QPopupMenu();
  remote_action->addTo(rem_menu);




  viewMenu=new QPopupMenu();
  viewMenu->setCheckable(true);
  viewToolBar->addTo(viewMenu);
  viewStatusBar->addTo(viewMenu);

  helpMenu=new QPopupMenu();

  helpMenu->insertItem("Help",this, SLOT(slotHelpAbout()), 0, ID_HELP_ABOUT);
  helpMenu->insertSeparator();
  helpMenu->insertItem("About...", this, SLOT(slotHelp()), 0, ID_HELP_HELP);






  menuBar()->insertItem(tr("&File"), fileMenu);

  menuBar()->insertItem(tr("&View"), viewMenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(tr("&Config"), confmenu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(tr("&Remote"), rem_menu);
  menuBar()->insertSeparator();
  menuBar()->insertItem(tr("&Help"), helpMenu);

}

void MosixviewApp::initToolBar()
{
  fileToolbar = new QToolBar(this, "file operations");
  fileOpen->addTo(fileToolbar);
  fileToolbar->addSeparator();
	remote_action->addTo(fileToolbar);
  fileToolbar->addSeparator();
  QWhatsThis::whatsThisButton(fileToolbar);
  fileToolbar->addSeparator();
	helpAboutApp->addTo(fileToolbar);



}

void MosixviewApp::initStatusBar()
{
  statusBar()->message(tr("Ready."), 2000);
}



bool MosixviewApp::queryExit()
{
  int exit=QMessageBox::information(this, tr("Quit..."),
                                    tr("Do your really want to quit?"),
                                    QMessageBox::Ok, QMessageBox::Cancel);

  if (exit==1)
  {

  }
  else
  {

  };

  return (exit==1);
}





void MosixviewApp::slotFileOpen()
{

  statusBar()->message(tr("running programm..."));

  QString fileName = QFileDialog::getOpenFileName(0,0,this);
  if (!fileName.isEmpty())
  {

    QString message=tr("executed  ")+fileName;

		system(fileName+"&");

    statusBar()->message(message, 2000);

  }
  else
  {

    statusBar()->message(tr("running aborted"), 2000);

  }

}





void MosixviewApp::slotViewToolBar(bool toggle)
{
  statusBar()->message(tr("Toggle toolbar..."));

  if (toggle== false)
  {
    fileToolbar->hide();
  }
  else
  {
    fileToolbar->show();
  };

  statusBar()->message(tr("Ready."));
}

void MosixviewApp::slotViewStatusBar(bool toggle)
{
  statusBar()->message(tr("Toggle statusbar..."));

  if (toggle == false)
  {
    statusBar()->hide();
  }
  else
  {
    statusBar()->show();
  }

  statusBar()->message(tr("Ready."));
}







void MosixviewApp::slotHelpAbout()
{


 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);


  QPixmap help, prem, conf, com, lo, procicon_g, smile, fresh, migrat;
	help = QPixmap(helpicon);
	prem = QPixmap(remote);
	conf = QPixmap(config);
	lo = QPixmap(load);
	com = QPixmap(comment);
	procicon_g= QPixmap(proc_g);
	smile = QPixmap(speed);
	fresh = QPixmap(refresh);
	migrat = QPixmap(migrator);



QTabDialog *tabs = new QTabDialog();

tabs->setGeometry(200,50,300,200);
tabs->resize(500, 300);

QLabel *a = new QLabel(tabs, 0, 0);
a->setGeometry(5,5,20,20);
a->resize(200, 200);
a->setMargin(3);
a->setFrameStyle( QFrame::Panel | QFrame::Sunken );
a->setBackgroundPixmap(QPixmap(white_pix));
a->setText("Help on MOSIXVIEW\n\nMOSIXVIEW is designed to manage MOSIX-Cluster.\n"	\

	"(more information on the great MOSIX on www.mosix.org\n" \
	"MOSIX is developed at the university of Jerusalem)\n" \
	"It gives an overview of what happen on your system(s)\nand helps to distribute processes to the best avaiable nodes\n" \
	"automatically or manually. The configuration of each.\n" \
	"cluster-member can be change by dialogs-windows.\n\n" \
	"I hope this free software is usefull for you and your are\n" \
	"invited to send me your comments or wanted features.\n\n" \
	"M. Rechenburg / rechenburger@netcologne.de");

QLabel *b = new QLabel(tabs, 0, 0);
b->setGeometry(5,5,20,20);
b->resize(200, 200);
b->setMargin(3);
b->setFrameStyle( QFrame::Panel | QFrame::Sunken );
b->setBackgroundPixmap(QPixmap(white_pix));
b->setText("Config your cluster\n\nIf you click on an host-button a configuration-dialog will pop up\n"	\

	"The following most common use mosix-commands can be execute\n" \
	"on every cluster-node:\n" \
	"automigration on/off, quiet yes/no, bring/lstay yes/no,\n" \
	"expel yes/no, mosix stop/start.\n\n" \
	"(if the nslookup-checkbox is checked MOSIXVIEW will lookup the\n" \
	"hostname and ip-adress in the configuration-dialog.\n" \
	"Do not use this option if your cluster-nodes only have\n" \
	"ip-adresses and no hostnames (e.g. DNS or /etc/hosts entry).\n" \
	"If MOSIXVIEW cannot find the hostname it will quit!)\n");



QLabel *c = new QLabel(tabs, 0, 0);
c->setGeometry(5,5,20,20);
c->resize(200, 200);
c->setMargin(3);
c->setFrameStyle( QFrame::Panel | QFrame::Sunken );
c->setBackgroundPixmap(QPixmap(white_pix));
c->setText("Set the speed/priority of each node\n\nYou can adjust the mosix-speed with the sliders for each node.\n"	\

	"Processes will easier migrate to cluster-nodes with more mosix-speed.\n" \
	"Just increase the speed of one host which less load and the load\n" \
	"will also increase because MOSIX 'thinks' that this host can handle\n" \
	"more processes and will migrate processes to.\n" \
	"If an host has too much load, decrease the speed and the load will\n" \
	"decrease, too.\n\n" \
	"Use the speed-sliders to set the priority for each cluster-member.\n" \
	"Of course you can change this also at runtime.\n" \
	"Managing the load-balancing manually or automatically is easy now.\n");



QLabel *d = new QLabel(tabs, 0, 0);
d->setGeometry(5,5,20,20);
d->resize(200, 200);
d->setMargin(3);
d->setFrameStyle( QFrame::Panel | QFrame::Sunken );
d->setBackgroundPixmap(QPixmap(white_pix));
d->setText("Too much load?\n\nThere is not much to say about the load-progressbar.\n"	\

	"The load is count in percent so it just gives you an overview\n" \
	"of the load. It does not exactly represent the the value of\n" \
	"/proc/mosix/nodes/x/load of each node!\n" \
	"It maybe will be changed in the future.\n" \
	"\n" \
	"\n\n" \
	"\n" \
	"\n" \
	"\n");

QLabel *e = new QLabel(tabs, 0, 0);
e->setGeometry(5,5,20,20);
e->resize(200, 200);
e->setMargin(3);
e->setFrameStyle( QFrame::Panel | QFrame::Sunken );
e->setBackgroundPixmap(QPixmap(white_pix));
e->setText("Processes on your cluster\n\nOn the right part of the main-window is a processbox where\n"	\

	"you can watch all your running processes on the local maschine.\n" \
	"(you should start all procs from your 'local-node' because then\n" \
	"they appear in the process-list as local)\n" \
	"The processes are sorted by the column you click on.\n\n" \
	"Just double-click on a process and a new dialog-box will appear\n" \
	"in which you can choose the host you want the process to migrate\n" \
	"to. The second column shows the MOSIX-node number on which the\n" \
	"process is running. 0 stands for local, any other number is remote.\n" \
	"Remote processes are easy to recognize by the green proc-icon.\n");

QLabel *f = new QLabel(tabs, 0, 0);
f->setGeometry(5,5,20,20);
f->resize(200, 200);
f->setMargin(3);
f->setFrameStyle( QFrame::Panel | QFrame::Sunken );
f->setBackgroundPixmap(QPixmap(white_pix));
f->setText("Refresh or not refresh\n\nThe status, load or process-view can set to refresh\n"	\

	"automatically by the checkboxes or by the config-menu.\n" \
	"It may be usefull to decrease the network-traffic/load.\n" \
	"\n" \
	"Check the nslookup-checkbox if your nodes are in DNS or\n" \
	"have hostname-entries in your /etc/hosts file.\n" \
	"If MOSIXVIEW cannot lookup the hostname it will quit.\n\n" \
	"\n" \
	"\n" \
	"\n");

QLabel *g = new QLabel(tabs, 0, 0);
g->setGeometry(5,5,20,20);
g->resize(200, 200);
g->setMargin(3);
g->setFrameStyle( QFrame::Panel | QFrame::Sunken );
g->setBackgroundPixmap(QPixmap(white_pix));
g->setText("Managing procs from remote nodes\n\nBy clicking on the button below the processbox you can influence\n"	\

	"the processes from remote nodes running on this host.\n" \
	"The popup-window will show how many procs from remote are\n" \
	"currently migrated to this host and from where they come from.\n" \
	"\n" \
	"You can migrate one processes back to its home node or to the\n" \
	"best avaiable node in your cluster. If you choose the second\n" \
	"possibility MOSIX decides where the proc will go.\n" \
	"(this can also influenced by the speed-sliders)\n" \
	"\n" \
	"\n");



QLabel *h = new QLabel(tabs, 0, 0);
h->setGeometry(5,5,20,20);
h->resize(200, 200);
h->setMargin(3);
h->setFrameStyle( QFrame::Panel | QFrame::Sunken );
h->setBackgroundPixmap(QPixmap(white_pix));
h->setText("Remote processbox\n\nIn the configuration window of each host you can\n"	\

	"click on the remote-procbox-button to open a remote migrator-box.\n" \
	"If properly installed on each cluster-node this button executes a\n" \
	"xhost +hostname local on your maschine to allow remote X-apps to be\n" \
	"displayed. After that it runs a rsh to the node open a minimized version of\n" \
	"MOSIXVIEW. Mainly it is the processbox already known by the main application.\n" \
	"It has the whole functionality like the normal MOSIXVIEW. You can look\n" \
	"what is started and running on the remote host in an easy way.\n" \
	"(play with it to understand)\n" \
	"The MOSIXVIEW-Client binary must be installed in /usr/bin/ on each node to\n" \
	"use this option.\n");




QLabel *i = new QLabel(tabs, 0, 0);
i->setGeometry(5,5,20,20);
i->resize(200, 200);
i->setMargin(3);
i->setFrameStyle( QFrame::Panel | QFrame::Sunken );
i->setBackgroundPixmap(QPixmap(white_pix));
i->setText("Comments on MOSIXVIEW\n\nMOSIXVIEW is still under development and i am looking\n"	\

	"forward to any comment, bug report and wanted features.\n" \
	"\n" \
	"I also want to use this for saying thanks to Prof. Amnon Barak\n" \
	"and his developers for the great work they do on MOSIX.\n" \
	"Thanks to all testers of MOSIXVIEW who report bugs/probs ot me.\n" \
	"Last but not least a warm thanks also to my wife who\n" \
	"gives me the time for developing, clustering, linuxing,\n" \
	"fixing problems, installing, trying new software.....\n" \
	"\n" \
	"Hope you have fun with MOSIXVIEW.\n");



tabs->addTab(a, help,  "general");
tabs->addTab(b, conf,  "config");
tabs->addTab(c, smile, "speed");
tabs->addTab(d, lo, "load");
tabs->addTab(e, procicon_g, "procs");
tabs->addTab(f, fresh, "refresh");
tabs->addTab(g, prem, "remote");
tabs->addTab(h, migrat, "migrator");
tabs->addTab(i, com, "comments");


tabs->show();





}





void MosixviewApp::slotHelp()
{
  QMessageBox::about(this,"About...",
                     IDS_APP_ABOUT );

}








void MosixviewApp::toggle_config_stat()
{

   if (confmenu->isItemChecked(ID_STAT))
  {
   confmenu->setItemChecked(ID_STAT, false);
	QCheckBox_2->toggle();
  }
  else
  {
   confmenu->setItemChecked(ID_STAT, true);
	QCheckBox_2->toggle();

  }
}







void MosixviewApp::toggle_config_ns()
{

   if (confmenu->isItemChecked(ID_CONFIG))
  {
   confmenu->setItemChecked(ID_CONFIG, false);
	QCheckBox_3->toggle();
  }
  else
  {
   confmenu->setItemChecked(ID_CONFIG, true);
	QCheckBox_3->toggle();

  }


}


void MosixviewApp::toggle_ns_menu(bool on)
{

   if (!on)
  {
   confmenu->setItemChecked(ID_CONFIG, false);
  }
  else
  {
   confmenu->setItemChecked(ID_CONFIG, true);
  }
}






void MosixviewApp::toggle_stat_menu(bool on)
{

   if (!on)
  {
   confmenu->setItemChecked(ID_STAT, false);
  }
  else
  {
   confmenu->setItemChecked(ID_STAT, true);
  }
}






void MosixviewApp::toggle_config_load()
{

   if (confmenu->isItemChecked(ID_LOAD))
  {
   confmenu->setItemChecked(ID_LOAD, false);
	QCheckBox_4->toggle();
  }
  else
  {
   confmenu->setItemChecked(ID_LOAD, true);
	QCheckBox_4->toggle();

  }
}


void MosixviewApp::toggle_load_menu(bool on)
{

   if (!on)
  {
   confmenu->setItemChecked(ID_LOAD, false);
  }
  else
  {
   confmenu->setItemChecked(ID_LOAD, true);
  }
}







void MosixviewApp::toggle_config_procs()
{

   if (confmenu->isItemChecked(ID_PROCS))
  {
   confmenu->setItemChecked(ID_PROCS, false);
	QCheckBox_1->toggle();
  }
  else
  {
   confmenu->setItemChecked(ID_PROCS, true);
	QCheckBox_1->toggle();

  }
}


void MosixviewApp::toggle_proc_menu(bool on)
{

   if (!on)
  {
   confmenu->setItemChecked(ID_PROCS, false);
  }
  else
  {
   confmenu->setItemChecked(ID_PROCS, true);
  }
}












void MosixviewApp::remoteproc()
{


	int procs=0;

	DIR *dir;
	struct dirent *dir_info;
	FILE *fp;
	char from[6];
	char ip_from[20];
	char temp[100];



 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

 	QPixmap procicon_g;
	procicon_g= QPixmap(proc_g);



//  QMessageBox::information(this,"HELP on MOSIXVIEW", IDS_APP_HELP );


QTabDialog *rem = new QTabDialog();

rem->setGeometry(600,250,300,200);
rem->resize(300, 300);



	if ((dir=opendir("/proc/mosix/remote"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {


	if((strchr(dir_info->d_name, '1'))||(strchr(dir_info->d_name, '2'))||(strchr(dir_info->d_name, '3'))||(strchr(dir_info->d_name, '4'))||(strchr(dir_info->d_name, '5'))||(strchr(dir_info->d_name, '6'))||(strchr(dir_info->d_name, '7'))||(strchr(dir_info->d_name, '8'))||(strchr(dir_info->d_name, '9')) ) {

			procs++;

        strcpy(temp, "");
        strcpy(temp, "/proc/mosix/remote/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/from");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s %s", from, ip_from);
            fclose(fp);
        }


	rem_processbox[procs] = new QLabel(rem);
	rem_processbox[procs]->setGeometry(10,10,300,300);
	rem_processbox[procs]->setMinimumSize(0,0);

	rem_from_who_label[procs] = new QLabel(rem_processbox[procs]);
	rem_from_who_label[procs]->setGeometry(10,10,140,20);
	rem_from_who_label[procs]->setMinimumSize(0,0);
	rem_from_who_label[procs]->setMargin(3);
	rem_from_who_label[procs]->setText("from MOSIX-node:");

	rem_from_ip_label[procs] = new QLabel(rem_processbox[procs]);
	rem_from_ip_label[procs]->setGeometry(10,40,140,20);
	rem_from_ip_label[procs]->setMinimumSize(0,0);
	rem_from_ip_label[procs]->setMargin(3);
	rem_from_ip_label[procs]->setText("IP-adress of the node:");




	rem_from_who[procs] = new QLabel(rem_processbox[procs]);
	rem_from_who[procs]->setGeometry(150,10,30,20);
	rem_from_who[procs]->setMinimumSize(0,0);
	rem_from_who[procs]->setMargin(3);
	rem_from_who[procs]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	rem_from_who[procs]->setBackgroundPixmap(QPixmap(white_pix));
	rem_from_who[procs]->setText(from);

	rem_from_ip[procs] = new QLabel(rem_processbox[procs]);
	rem_from_ip[procs]->setGeometry(150,40,100,20);
	rem_from_ip[procs]->setMinimumSize(0,0);
	rem_from_ip[procs]->setMargin(3);
	rem_from_ip[procs]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	rem_from_ip[procs]->setBackgroundPixmap(QPixmap(white_pix));
	rem_from_ip[procs]->setText(ip_from);



  rem_gohome[procs]=  new QPushButton(rem_processbox[procs],dir_info->d_name);
  rem_gohome[procs]->setGeometry(20,90,100,25);
  rem_gohome[procs]->setMinimumSize(0,0);
  rem_gohome[procs]->setText("goto home node");
	QObject::connect( rem_gohome[procs], SIGNAL(clicked()), this, SLOT( remote_gohome()) );
	QWhatsThis::add(rem_gohome[procs] ,"Click to migrate this process to its home node.\n");



  rem_gobest[procs]=  new QPushButton(rem_processbox[procs],dir_info->d_name);
  rem_gobest[procs]->setGeometry(20,120,100,25);
  rem_gobest[procs]->setMinimumSize(0,0);
  rem_gobest[procs]->setText("goto best node");
	QObject::connect( rem_gobest[procs], SIGNAL(clicked()), this, SLOT( remote_gobest()) );
	QWhatsThis::add(rem_gobest[procs] ,"Click to migrate this process to the best node.\n");





	rem->addTab(rem_processbox[procs], procicon_g, dir_info->d_name);



    }

	} //while

closedir(dir);
} //if



if (procs==0) {

	rem_processbox[procs] = new QLabel(rem);
	rem_processbox[procs]->setGeometry(10,10,300,300);
	rem_processbox[procs]->setMinimumSize(0,0);

	rem_from_who_label[procs] = new QLabel(rem_processbox[procs]);
	rem_from_who_label[procs]->setGeometry(10,10,200,60);
	rem_from_who_label[procs]->setMinimumSize(0,0);
	rem_from_who_label[procs]->setMargin(3);
	rem_from_who_label[procs]->setBackgroundPixmap(QPixmap(white_pix));
	rem_from_who_label[procs]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	rem_from_who_label[procs]->setText("No processes from remote\nnodes running on this host!");

	rem->addTab(rem_processbox[procs], procicon_g, "none");


	}


rem->show();





}












void MosixviewApp::remote_gohome()
{

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	const char *proctab;
	const QObject *button = sender();
  proctab=button->name();

	char setsp[100]="";
	char outp[100]="";

	int error;


	strcpy(outp, "remote proc goes home now");

	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

	strcpy(setsp, "");
	strcpy(setsp, "echo 0 > /proc/mosix/remote/");
	strcat(setsp, proctab);
	strcat(setsp, "/goto");
	if((error=system(setsp)) > 0) {
        printf("cannot send proc home\n");

				strcpy(outp, "cannot send remote proc home");
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }

}






void MosixviewApp::remote_gobest()
{


 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	const char *proctab;
	const QObject *button = sender();
  proctab=button->name();

	char setsp[100]="";
	char outp[100]="";

	int error;


	strcpy(outp, "remote proc send to the best avaiable node now");

	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

	strcpy(setsp, "");
	strcpy(setsp, "echo -1 > /proc/mosix/remote/");
	strcat(setsp, proctab);
	strcat(setsp, "/goto");
	if((error=system(setsp)) > 0) {
        printf("cannot send proc to best avaiable node\n");

				strcpy(outp, "cannot send remote proc to best avaiable node");
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }



}
















void MosixviewApp::open_remoteprocs()
{


 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	const char *hostname;
	const QObject *button = sender();
  hostname=button->name();

	char setsp[150]="";
	char setsp1[100]="";
	char outp[100]="";

	int error;



	strcpy(outp, "open a remote processbox");

	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));



	QFile fp("/etc/HOSTNAME");

	if ( fp.open(IO_ReadOnly) ) {    // file opened successfully
		QTextStream t( &fp );        // use a text stream
		QString s;


			s = t.readLine();       // line of text excluding '\n'
			s = s.simplifyWhiteSpace();

		fp.close();





	strcpy(setsp1, "");
	strcpy(setsp1, "xhost +");
	strcat(setsp1, hostname);
	if((error=system(setsp1)) > 0) {
        printf("cannot set xhost + for remote host\n");
        } else {
        printf("set xhost + for remote host\n");
                }

	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/rsh ");
	strcat(setsp, hostname);
	strcat(setsp, " /usr/bin/mosixview_client -display ");
	strcat(setsp, s);
	strcat(setsp, ":0.0&");

	if((error=system(setsp)) > 0) {
        printf("cannot open remote processbox\n");

				strcpy(outp, "cannot open remote processbox");
				QLabel_111->setText(outp);
				QLabel_111->setBackgroundPixmap(QPixmap(white_pix));

        }



 } else {
	printf("failed to get local hostname\n");
	strcpy(outp, "failed to get local hostname");
	QLabel_111->setText(outp);
	QLabel_111->setBackgroundPixmap(QPixmap(white_pix));


	}

}






















