/***************************************************************************
                          mosixview.h  -  description
                             -------------------
    begin                : Tue Jun 26 16:06:00 GMT 2001
    copyright            : (C) 2001 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MOSIXVIEW_H
#define MOSIXVIEW_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qscrollbar.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlistview.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include <qprogressbar.h>
#include <qlistbox.h>
#include <qaccel.h>
#include <qlistbox.h>
#include <qtextstream.h>
#include <qtabdialog.h>



#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <dirent.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>



#include "resource.h"








// application specific includes
#include "mosixviewview.h"
#include "mosixviewdoc.h"

/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class MosixviewView is
  * created which creates your view.
  */
class MosixviewApp : public QMainWindow
{
  Q_OBJECT
  
  public:


    void initDialog();







    /** construtor */
    MosixviewApp();
    /** destructor */
    ~MosixviewApp();

    void initActions();
    void initMenuBar();
    void initToolBar();
    void initStatusBar();
    bool queryExit();

  public slots:

    void slotFileOpen();
    void slotViewToolBar(bool toggle);
    void slotViewStatusBar(bool toggle);
    void slotHelpAbout();
		void slotHelp();

	void setupQuit();
	void scroll_view(int value);
	void getconfig();
	void typval();
	void getval();
	void setspeed(int speed);

	void toggle_ns_menu(bool on);
	void toggle_config_ns();

	void toggle_stat_menu(bool on);
	void toggle_config_stat();
	void toggle_load_menu(bool on);
	void toggle_config_load();
	void toggle_proc_menu(bool on);
	void toggle_config_procs();

	void action_lstay();
	void action_nolstay();
	void action_migration();
	void action_nomigration();
	void action_stop();
	void action_start();
	void action_block();
	void action_noblock();
	void action_noquiet();
	void action_quiet();
	void neuwin();
	void neuwin1();
	void close_config();
	void mosixstatus();
	void labelconf();
	void labelit( QListViewItem * index);
	void migrateto(int index);
	void migratehome();
	void migratebest();

	void refreshit();
	void refreshitmanual();
	void refreshit_status();
	void refreshit_status_manual();
	void fill_procbox();
	void closehostbox();
	void killproc();

	void remoteproc();
	void remote_gohome();
	void remote_gobest();

	void open_remoteprocs();



protected:



	QScrollBar *QScrollBar_1;
	QCheckBox *QCheckBox_1;
	QPushButton *QPushButton_70;
	QPushButton *QPushButton_1;
	QGroupBox *QGroupBox_1;
	QLabel *QLabel_22;
	QLabel *QLabel_6;
	QLabel *QLabel_2;
	QLabel *QLabel_52;
	QLabel *QLabel_50;
	QLabel *QLabel_110;
	QLabel *QLabel_111;
	QPushButton *QPushButton_73;

	QPushButton *QPushButton_home;
	QPushButton *QPushButton_best;
	QLabel *home_label;
	QLabel *best_label;
	QLabel *home_label1;
	QLabel *best_label1;
	QLabel *or_label;
	QLabel *proc_label;
	QLabel *proc_titel;
	QLabel *pix_titel;

	QPushButton *QPushButton_rem;
	QCheckBox *QCheckBox_2;
	QCheckBox *QCheckBox_3;
	QCheckBox *QCheckBox_4;

	QLabel *QLabel_host[1000];
	QLabel *QLabel_stat[1000];
	QSlider *QSlider_host[1000];
	QLCDNumber *QLCDNumber_host[1000];



	QProgressBar *QProgressBar_host[1000];
	QPushButton *QPushButton_host[1000];

	QPushButton *proc_remotebox;

	QPushButton *QPushButton_2;
	QPushButton *QPushButton_12;
	QPushButton *QPushButton_30;
	QPushButton *QPushButton_40;
	QPushButton *QPushButton_50;
	QPushButton *QPushButton_60;
	QPushButton *QPushButton_71;
	QPushButton *QPushButton_72;
	QPushButton *QPushButton_80;
	QPushButton *QPushButton_90;
	QPushButton *QPushButton_81;
	QPushButton *QPushButton_91;
	QPushButton *QPushButton_14;

	QLabel *QLabel_hostconf;
	QLabel *QLabel_hostconf1;
	QLabel *QLabel_hostconf2;
	QLabel *QLabel_hostconf3;
	QLabel *QLabel_hostconf4;
	QLabel *QLabel_hostconf5;
	QLabel *QLabel_hostconf6;
	QLabel *QLabel_hostconf7;
	QLabel *QLabel_hostconf8;
	QLabel *QLabel_hostconf9;
	QLabel *QLabel_conficon;

	QListView *processbox;
  QWidget *hinten;
  QWidget *hinten1;


	QTabDialog *rem;
	QLabel *rem_processbox[500];
	QLabel *rem_from_who[500];
	QLabel *rem_from_ip[500];
	QLabel *rem_from_who_label[500];
	QLabel *rem_from_ip_label[500];

	QPushButton *rem_gohome[500];
	QPushButton *rem_gobest[500];




  private:

    MosixviewView *view;
    MosixviewDoc *doc;
  
    QPopupMenu *fileMenu;
    QPopupMenu *confmenu;
    QPopupMenu *viewMenu;
    QPopupMenu *rem_menu;
    QPopupMenu *helpMenu;
    QToolBar *fileToolbar;
    QAction *fileOpen;
    QAction *fileQuit;

    QAction *config_stat;
    QAction *viewToolBar;
    QAction *viewStatusBar;
    QAction *helpAboutApp;
    QAction *remote_action;
};
#endif 

