/***************************************************************************
                          mosixview_client.cpp  -  description
                             -------------------
    begin                : Fri Jul  6 19:44:05 GMT 2001
    copyright            : (C) 2001 by M. Rechenburg
    email                : rechenburger@netcologne.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qaccel.h>
#include "mosixview_client.h"

#include "white.xpm"
#include "hosti.xpm"
#include "proc.xpm"
#include "proc_g.xpm"
#include "proc_remote.xpm"
#include "refresh.xpm"
#include "speed.xpm"
#include "migrator.xpm"
#include "gohome.xpm"
#include "kill.xpm"
#include "ende.xpm"














Mosixview_clientApp::Mosixview_clientApp()
{

	QFile fp("/etc/HOSTNAME");

	if ( fp.open(IO_ReadOnly) ) {    // file opened successfully
		QTextStream t( &fp );        // use a text stream
		QString s;

			s = t.readLine();       // line of text excluding '\n'
			s = s.simplifyWhiteSpace();


  setCaption(tr("procs on "+ s));

		fp.close();

 } else {

  setCaption(tr("procs on localhost"));
}

	initDialog();


}

Mosixview_clientApp::~Mosixview_clientApp()
{
}








void  Mosixview_clientApp::initDialog(){


	QPixmap white_pix, fresh, end;
	white_pix= QPixmap(white_xpm);
	fresh = QPixmap(refresh);
	end = QPixmap(ende);


  QCheckBox_1= new QCheckBox(this,"NoName");
  QCheckBox_1->setGeometry(85,35,100,20);
  QCheckBox_1->setMinimumSize(0,0);
  QCheckBox_1->setText("auto-refresh");
  QCheckBox_1->setChecked(true);



  QPushButton_70= new QPushButton(fresh, "NoName", this);
  QPushButton_70->setGeometry(5,35,70,20);
  QPushButton_70->setMinimumSize(0,0);
  QPushButton_70->setText("refresh");
	QObject::connect( QPushButton_70, SIGNAL(clicked()), this, SLOT( refreshitmanual()) );



  QPushButton_1= new QPushButton(end, "NoName", this);
  QPushButton_1->setGeometry(130,385,60,20);
  QPushButton_1->setMinimumSize(0,0);
  QPushButton_1->setText("quit");
	QObject::connect(QPushButton_1, SIGNAL(clicked()), qApp, SLOT(quit()) );


  QLabel_52= new QLabel(this,"NoName");
  QLabel_52->setGeometry(5,5,100,20);
  QLabel_52->setMinimumSize(0,0);
  QLabel_52->setText("managed proc:");
  QLabel_52->setMargin(2);




  QLabel_50= new QLabel(this,"NoName");
  QLabel_50->setGeometry(110,5,70,20);
  QLabel_50->setMinimumSize(0,0);
  QLabel_50->setBackgroundPixmap(QPixmap(white_pix));
  QLabel_50->setText("");
  QLabel_50->setMargin(3);
	QLabel_50->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	QLabel_50->setAlignment( AlignVCenter | AlignRight );


  QPushButton_73= new QPushButton(fresh , "NoName", this);
  QPushButton_73->setGeometry(5,60,65,20);
  QPushButton_73->setMinimumSize(0,0);
  QPushButton_73->setText("refresh");

  QPushButton_rem= new QPushButton(this,"NoName");
  QPushButton_rem->setGeometry(5,370,90,35);
  QPushButton_rem->setMinimumSize(0,0);
  QPushButton_rem->setText("manage procs\nfrom remote");


}







void Mosixview_clientApp::setupQuit(){

	printf("Initializing MOSIXVIEW-CLIENT...\n");


	neuwin();

	QTimer *proctimer = new QTimer( this );
	proctimer->start( 10000 );
	connect( proctimer, SIGNAL(timeout()), this, SLOT(refreshit()) );
	QObject::connect( QPushButton_rem, SIGNAL(clicked()), this, SLOT( remoteproc()) );


}







	void Mosixview_clientApp::closehostbox() {

	delete hinten;
}





	void Mosixview_clientApp::refreshit() {

	if(QCheckBox_1->isChecked()) {
		fill_procbox();
		}


}



	void Mosixview_clientApp::refreshitmanual() {

		fill_procbox();

}





	void Mosixview_clientApp::killproc() {

	char killprocnr[50];
	char outp[100]="";
	int error;
	const char *cproc;
	const QObject *button = sender();

	cproc=button->name();

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	strcpy(killprocnr, "");
	strcpy(killprocnr, "/bin/kill ");
	strcat(killprocnr, cproc);
	if((error=system(killprocnr)) > 0) {
        printf("cannot kill proc\n");
	strcpy(outp, "cannot kill PID ");
	strcat(outp, cproc);

        }

	strcpy(outp, "killed PID ");
	strcat(outp, cproc);

}








void Mosixview_clientApp::neuwin(){

	processbox = new QListView(this);
	processbox->setGeometry(5,60,50,100);
	processbox->setMinimumSize(0,0);
	processbox->setAllColumnsShowFocus(1);
	processbox->addColumn("pid");
	processbox->addColumn("n#");
	processbox->addColumn("stat");
	processbox->addColumn("cmdline");


	processbox->setSorting(2, TRUE);

	processbox->setColumnAlignment (0, AlignLeft);
	processbox->setColumnAlignment (1, AlignLeft);
	processbox->setColumnAlignment (2, AlignLeft);
	processbox->setItemMargin(2);
	processbox->resize(190, 300);
	fill_procbox();
	processbox->show();
	QObject::connect( processbox, SIGNAL(doubleClicked(QListViewItem *)), this, SLOT( labelit( QListViewItem *)) );





}



	void Mosixview_clientApp::labelit( QListViewItem *index) {

 int character='#';
	const char *hostname;
	const char *range;
	char *sub_string1=new char[50];
	char *hostnametmp=new char[50];
	char *new_last_bit=new char[5];
	int lang=0;
	int howmany=0;
	int p=0;
	int lastbit=0;
	int lang_lastbit=0;
	int lang_hostname=0;
	int lang_oldbit=0;
	int new_host_lang=0;
	char *host_ohne_bit=new char[50];
	int second=0;

	char output[250];

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

 	QPixmap host, migrat, home, smile, killit, end;
	host= QPixmap(hosti);
	migrat= QPixmap(migrator);
	home= QPixmap(gohome);
	smile = QPixmap(speed);
	killit = QPixmap(kill);
	end = QPixmap(ende);


	hinten = new QWidget(0, "");
	hinten->setGeometry(620,300,50,110);
	hinten->setMinimumSize(0,0);
	hinten->resize(170, 285);

	QGroupBox *backr2 = new QGroupBox("",hinten);
	backr2->setGeometry(5,25,50,130);
	backr2->setMinimumSize(0,0);
	backr2->resize(160, 255);

	QLabel *QLabel_proc = new QLabel("",backr2);
	QLabel_proc->setGeometry(10,90,20,30);
	QLabel_proc->setMinimumSize(0,0);
	QLabel_proc->resize(140, 100);

	QListBox *hostbox = new QListBox(hinten);
	hostbox->setGeometry(10,30,50,110);
	hostbox->setMinimumSize(0,0);
	hostbox->resize(150, 100);



	QFile fp("/etc/mosix.map");

	if ( fp.open(IO_ReadOnly) ) {    // file opened successfully
		QTextStream t( &fp );        // use a text stream
		QString s;
		int n = 0;
		while ( !t.eof() ) {        // until end of file...


			s = t.readLine();       // line of text excluding '\n'
			s = s.simplifyWhiteSpace();

if ( (s.find ( character, 0, TRUE )==-1)&&(s.length()>1) ) {

	second=	s.find ( 32, 0, TRUE );
	lang=	s.findRev ( 32, s.length(), TRUE );
	range=(const char *)s+(lang+1);


if ( (strcmp(range, "0"))||(strcmp(range, "ALIAS")) ) {


	howmany=atoi(range);

	if (howmany!=1){

	s.truncate( lang );
	hostname=(const char *)s+(second+1);

	for (p=0; p<howmany; p++) {

	n++;

	strcpy(hostnametmp, hostname);

  strtok((char *)hostnametmp, ".");
	sub_string1=strtok(NULL, ".");
	sub_string1=strtok(NULL, ".");
	sub_string1=strtok(NULL, ".");

	lastbit=atoi(sub_string1);

	sprintf(new_last_bit, "%d", lastbit+p);

	lang_oldbit=strlen(sub_string1);

	lang_lastbit=strlen(new_last_bit);
	lang_hostname=strlen(hostname);

	new_host_lang=lang_hostname-lang_oldbit;

	strncpy(host_ohne_bit, hostname, new_host_lang);

	host_ohne_bit[new_host_lang-1] = '.';
	host_ohne_bit[new_host_lang] = '\0';

	char *real_host=new char[strlen(host_ohne_bit)+lang_lastbit];
	strcpy(real_host, host_ohne_bit);
	strcat(real_host, new_last_bit);
	real_host[strlen(host_ohne_bit)+lang_lastbit] = '\0';

	hostbox->insertItem(host, real_host, n);

 delete real_host;

 																}

	} else {

	n++;

	s.truncate( lang );

	hostname=(const char *)s+(second+1);

	hostbox->insertItem(host, hostname, n);


          }


	}

                                    }
			}
		fp.close();
	}





	QObject::connect( hostbox, SIGNAL(selected(int)), this, SLOT( migrateto( int )) );

	QLabel_50->setText(index->text(0));
	QLabel_50->setBackgroundPixmap(QPixmap(white_pix));

	strcpy(output, "");
	strcpy(output, "doubleclick a mosix host \nfor migrating the process:\n");
		strcat(output, index->text(0));
		strcat(output, " (");
	strcat(output, index->text(1));
	strcat(output, ")\n");
	QLabel_proc->setText(output);

  QPushButton_71= new QPushButton(end, "close", hinten);
  QPushButton_71->setGeometry(100,255,60,20);
  QPushButton_71->setMinimumSize(0,0);
  QPushButton_71->setText("close");
	QObject::connect( QPushButton_71, SIGNAL(clicked()), hinten, SLOT( close()) );

  QPushButton_home= new QPushButton(home, index->text(0), hinten);
  QPushButton_home->setGeometry(60,185,60,20);
  QPushButton_home->setMinimumSize(0,0);
  QPushButton_home->setText("home");
  QPushButton_home->setName(index->text(0));
	QObject::connect( QPushButton_home, SIGNAL(clicked()), this, SLOT( migratehome()) );

  QPushButton_best= new QPushButton(smile, index->text(0), hinten);
  QPushButton_best->setGeometry(60,205,60,20);
  QPushButton_best->setMinimumSize(0,0);
  QPushButton_best->setText("best");
  QPushButton_best->setName(index->text(0));
	QObject::connect( QPushButton_best, SIGNAL(clicked()), this, SLOT( migratebest()) );

  QPushButton_72= new QPushButton(killit, index->text(0), hinten);
  QPushButton_72->setGeometry(60,225,60,20);
  QPushButton_72->setMinimumSize(0,0);
  QPushButton_72->setText("kill");
  QPushButton_72->setName(index->text(0));
	QObject::connect( QPushButton_72, SIGNAL(clicked()), this, SLOT( killproc()) );


	home_label = new QLabel("",hinten);
	home_label->setGeometry(15,185,40,20);
	home_label->setMinimumSize(0,0);
	home_label->setText("send to");

	best_label = new QLabel("",hinten);
	best_label->setGeometry(15,205,40,20);
	best_label->setMinimumSize(0,0);
	best_label->setText("send to");

	home_label1 = new QLabel("",hinten);
	home_label1->setGeometry(125,185,30,20);
	home_label1->setMinimumSize(0,0);
	home_label1->setText("node");

	best_label1 = new QLabel("",hinten);
	best_label1->setGeometry(125,205,30,20);
	best_label1->setMinimumSize(0,0);
	best_label1->setText("node");

	or_label = new QLabel("",hinten);
	or_label->setGeometry(15,225,40,20);
	or_label->setMinimumSize(0,0);
	or_label->setText("      or");

	proc_label = new QLabel("",hinten);
	proc_label->setGeometry(125,225,30,20);
	proc_label->setMinimumSize(0,0);
	proc_label->setText("proc.");


	proc_titel = new QLabel("",hinten);
	proc_titel->setGeometry(25,5,150,20);
	proc_titel->setMinimumSize(0,0);
	proc_titel->setText("MOSIXVIEW-Migrator");

	pix_titel = new QLabel("",hinten);
	pix_titel->setGeometry(5,5,20,20);
	pix_titel->setMinimumSize(0,0);
	pix_titel->setPixmap(migrat);;



	hinten->show();




	}





	void Mosixview_clientApp::migrateto(int index) {

	char setsp[100]="";
	char outp[100]="";
	int error;
	char cindex[5];
	const char *cproc;


 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	cproc=(const char *)QLabel_50->text();



		index++;

		strcpy(cindex, "");
		sprintf(cindex, "%d", index);


	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/migrate ");
	strcat(setsp, cproc);
	strcat(setsp, " ");

	strcat(setsp, cindex);
	if((error=system(setsp)) > 0) {
        printf("cannot migrate PID\n");

	strcpy(outp, "cannot migrate PID ");
	strcat(outp, cproc);

        }

	strcpy(outp, "try to migrate PID ");
	strcat(outp, cproc);

}









	void Mosixview_clientApp::migratehome() {

	char setsp[100]="";
	char outp[100]="";
	int error;
	const char *cproc;
	const QObject *button = sender();

	cproc=button->name();


 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);


	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/migrate ");
	strcat(setsp, cproc);
	strcat(setsp, " home");

	if((error=system(setsp)) > 0) {
        printf("cannot send PID home\n");

	strcpy(outp, "cannot send home PID ");
	strcat(outp, cproc);

        }

	strcpy(outp, "try to send home PID ");
	strcat(outp, cproc);


}










	void Mosixview_clientApp::migratebest() {

	char setsp[100]="";
	char outp[100]="";
	int error;
	const char *cproc;
	const QObject *button = sender();

	cproc=button->name();


 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);


	strcpy(setsp, "");
	strcpy(setsp, "/usr/bin/migrate ");
	strcat(setsp, cproc);
	strcat(setsp, " balance");

	if((error=system(setsp)) > 0) {
        printf("cannot send PID to best node\n");

	strcpy(outp, "cannot send to best node PID ");
	strcat(outp, cproc);

        }

	strcpy(outp, "try to send to best node PID ");
	strcat(outp, cproc);

}


















	void Mosixview_clientApp::fill_procbox() {

	DIR *dir;
	struct dirent *dir_info;
	FILE *fp;
	char cmdline[1000];
	char temp[1000];
	char where[5];
	char stat[1000];


 	QPixmap procicon, remoteprocicon;
	procicon= QPixmap(proc);
	remoteprocicon= QPixmap(proc_remote);

	processbox->clear();

	if ((dir=opendir("/proc"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {


	if((strchr(dir_info->d_name, '1'))||(strchr(dir_info->d_name, '2'))||(strchr(dir_info->d_name, '3'))||(strchr(dir_info->d_name, '4'))||(strchr(dir_info->d_name, '5'))||(strchr(dir_info->d_name, '6'))||(strchr(dir_info->d_name, '7'))||(strchr(dir_info->d_name, '8'))||(strchr(dir_info->d_name, '9')) ) {

        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/cmdline");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s", cmdline);
            fclose(fp);
        }

        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/where");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s", where);
            fclose(fp);
        }



        strcpy(temp, "");
        strcpy(temp, "/proc/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/stat");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s", stat);
            fscanf(fp, "%s", stat);
            fscanf(fp, "%s", stat);
            fclose(fp);
        }





		QListViewItem *i1;
		i1 = new QListViewItem(processbox, dir_info->d_name, where, stat, cmdline);

		if (atoi(where)==0) {
		i1->setPixmap(0, procicon);
      } else {
		i1->setPixmap(0, remoteprocicon);
		}



    }

	} //while

closedir(dir);
} //if


}










void Mosixview_clientApp::remoteproc()
{


	int procs=0;

	DIR *dir;
	struct dirent *dir_info;
	FILE *fp;
	char from[6];
	char ip_from[20];
	char temp[100];



 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

 	QPixmap procicon_g;
	procicon_g= QPixmap(proc_g);





QTabDialog *rem = new QTabDialog();

rem->setGeometry(600,250,300,200);
rem->resize(300, 300);



	if ((dir=opendir("/proc/mosix/remote"))!=NULL) {

        while ((dir_info = readdir(dir))!=NULL) {


	if((strchr(dir_info->d_name, '1'))||(strchr(dir_info->d_name, '2'))||(strchr(dir_info->d_name, '3'))||(strchr(dir_info->d_name, '4'))||(strchr(dir_info->d_name, '5'))||(strchr(dir_info->d_name, '6'))||(strchr(dir_info->d_name, '7'))||(strchr(dir_info->d_name, '8'))||(strchr(dir_info->d_name, '9')) ) {

			procs++;

        strcpy(temp, "");
        strcpy(temp, "/proc/mosix/remote/");
        strcat(temp, dir_info->d_name);
        strcat(temp, "/from");

       if ((fp=fopen(temp, "r"))!=NULL) {

            fscanf(fp, "%s %s", from, ip_from);
            fclose(fp);
        }


	rem_processbox[procs] = new QLabel(rem);
	rem_processbox[procs]->setGeometry(10,10,300,300);
	rem_processbox[procs]->setMinimumSize(0,0);

	rem_from_who_label[procs] = new QLabel(rem_processbox[procs]);
	rem_from_who_label[procs]->setGeometry(10,10,140,20);
	rem_from_who_label[procs]->setMinimumSize(0,0);
	rem_from_who_label[procs]->setMargin(3);
	rem_from_who_label[procs]->setText("from MOSIX-node:");

	rem_from_ip_label[procs] = new QLabel(rem_processbox[procs]);
	rem_from_ip_label[procs]->setGeometry(10,40,140,20);
	rem_from_ip_label[procs]->setMinimumSize(0,0);
	rem_from_ip_label[procs]->setMargin(3);
	rem_from_ip_label[procs]->setText("IP-adress of the node:");




	rem_from_who[procs] = new QLabel(rem_processbox[procs]);
	rem_from_who[procs]->setGeometry(150,10,30,20);
	rem_from_who[procs]->setMinimumSize(0,0);
	rem_from_who[procs]->setMargin(3);
	rem_from_who[procs]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	rem_from_who[procs]->setBackgroundPixmap(QPixmap(white_pix));
	rem_from_who[procs]->setText(from);

	rem_from_ip[procs] = new QLabel(rem_processbox[procs]);
	rem_from_ip[procs]->setGeometry(150,40,100,20);
	rem_from_ip[procs]->setMinimumSize(0,0);
	rem_from_ip[procs]->setMargin(3);
	rem_from_ip[procs]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	rem_from_ip[procs]->setBackgroundPixmap(QPixmap(white_pix));
	rem_from_ip[procs]->setText(ip_from);



  rem_gohome[procs]=  new QPushButton(rem_processbox[procs],dir_info->d_name);
  rem_gohome[procs]->setGeometry(20,90,100,25);
  rem_gohome[procs]->setMinimumSize(0,0);
  rem_gohome[procs]->setText("goto home node");
	QObject::connect( rem_gohome[procs], SIGNAL(clicked()), this, SLOT( remote_gohome()) );
	QWhatsThis::add(rem_gohome[procs] ,"Click to migrate this process to its home node.\n");



  rem_gobest[procs]=  new QPushButton(rem_processbox[procs],dir_info->d_name);
  rem_gobest[procs]->setGeometry(20,120,100,25);
  rem_gobest[procs]->setMinimumSize(0,0);
  rem_gobest[procs]->setText("goto best node");
	QObject::connect( rem_gobest[procs], SIGNAL(clicked()), this, SLOT( remote_gobest()) );
	QWhatsThis::add(rem_gobest[procs] ,"Click to migrate this process to the best node.\n");





	rem->addTab(rem_processbox[procs], procicon_g, dir_info->d_name);



    }

	} //while

closedir(dir);
} //if



if (procs==0) {

	rem_processbox[procs] = new QLabel(rem);
	rem_processbox[procs]->setGeometry(10,10,300,300);
	rem_processbox[procs]->setMinimumSize(0,0);

	rem_from_who_label[procs] = new QLabel(rem_processbox[procs]);
	rem_from_who_label[procs]->setGeometry(10,10,200,60);
	rem_from_who_label[procs]->setMinimumSize(0,0);
	rem_from_who_label[procs]->setMargin(3);
	rem_from_who_label[procs]->setBackgroundPixmap(QPixmap(white_pix));
	rem_from_who_label[procs]->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	rem_from_who_label[procs]->setText("No processes from remote\nnodes running on this host!");

	rem->addTab(rem_processbox[procs], procicon_g, "none");


	}


rem->show();





}












void Mosixview_clientApp::remote_gohome()
{

 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	const char *proctab;
	const QObject *button = sender();
  proctab=button->name();

	char setsp[100]="";

	int error;


	strcpy(setsp, "");
	strcpy(setsp, "echo 0 > /proc/mosix/remote/");
	strcat(setsp, proctab);
	strcat(setsp, "/goto");
	if((error=system(setsp)) > 0) {
        printf("cannot send proc home\n");

        }

}






void Mosixview_clientApp::remote_gobest()
{


 	QPixmap white_pix;
	white_pix= QPixmap(white_xpm);

	const char *proctab;
	const QObject *button = sender();
  proctab=button->name();

	char setsp[100]="";

	int error;


	strcpy(setsp, "");
	strcpy(setsp, "echo -1 > /proc/mosix/remote/");
	strcat(setsp, proctab);
	strcat(setsp, "/goto");
	if((error=system(setsp)) > 0) {
        printf("cannot send proc to best avaiable node\n");

        }



}





























